import{S as On,i as Wn,s as zn,e as n,k as h,w,t as i,M as Vn,c as a,d as t,m as u,a as s,x as y,h as l,b as c,G as e,g as x,y as k,q as L,o as M,B as E,v as Rn,L as Qr}from"../../chunks/vendor-hf-doc-builder.js";import{T as Ke}from"../../chunks/Tip-hf-doc-builder.js";import{D as z}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Yr}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as so}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Kr}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Hn(D){let r,v;return{c(){r=n("p"),v=i("This function is experimental and might change in the future.")},l(d){r=a(d,"P",{});var f=s(r);v=l(f,"This function is experimental and might change in the future."),f.forEach(t)},m(d,f){x(d,r,f),e(r,v)},d(d){d&&t(r)}}}function Bn(D){let r,v,d,f,$,p,b,T;return{c(){r=n("p"),v=i("It is required to be logged in ("),d=n("code"),f=i("huggingface-cli login"),$=i(") when you want to use private or "),p=n("a"),b=i(`gated
models`),T=i("."),this.h()},l(m){r=a(m,"P",{});var _=s(r);v=l(_,"It is required to be logged in ("),d=a(_,"CODE",{});var C=s(d);f=l(C,"huggingface-cli login"),C.forEach(t),$=l(_,") when you want to use private or "),p=a(_,"A",{href:!0,rel:!0});var N=s(p);b=l(N,`gated
models`),N.forEach(t),T=l(_,"."),_.forEach(t),this.h()},h(){c(p,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),c(p,"rel","nofollow")},m(m,_){x(m,r,_),e(r,v),e(r,d),e(d,f),e(r,$),e(r,p),e(p,b),e(r,T)},d(m){m&&t(r)}}}function Gn(D){let r,v;return{c(){r=n("p"),v=i("This function is experimental and might change in the future.")},l(d){r=a(d,"P",{});var f=s(r);v=l(f,"This function is experimental and might change in the future."),f.forEach(t)},m(d,f){x(d,r,f),e(r,v)},d(d){d&&t(r)}}}function Xn(D){let r,v,d,f,$,p,b,T;return{c(){r=n("p"),v=i("It is required to be logged in ("),d=n("code"),f=i("huggingface-cli login"),$=i(") when you want to use private or "),p=n("a"),b=i(`gated
models`),T=i("."),this.h()},l(m){r=a(m,"P",{});var _=s(r);v=l(_,"It is required to be logged in ("),d=a(_,"CODE",{});var C=s(d);f=l(C,"huggingface-cli login"),C.forEach(t),$=l(_,") when you want to use private or "),p=a(_,"A",{href:!0,rel:!0});var N=s(p);b=l(N,`gated
models`),N.forEach(t),T=l(_,"."),_.forEach(t),this.h()},h(){c(p,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),c(p,"rel","nofollow")},m(m,_){x(m,r,_),e(r,v),e(r,d),e(d,f),e(r,$),e(r,p),e(p,b),e(r,T)},d(m){m&&t(r)}}}function Jn(D){let r,v,d,f,$,p,b,T;return b=new Yr({props:{code:`from diffusers import StableDiffusionPipeline
import torch

model_id = "runwayml/stable-diffusion-v1-5"
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

pipe.load_textual_inversion("sd-concepts-library/cat-toy")

prompt = "A <cat-toy> backpack"

image = pipe(prompt, num_inference_steps=50).images[0]
image.save("cat-backpack.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

model_id = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.load_textual_inversion(<span class="hljs-string">&quot;sd-concepts-library/cat-toy&quot;</span>)

prompt = <span class="hljs-string">&quot;A &lt;cat-toy&gt; backpack&quot;</span>

image = pipe(prompt, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;cat-backpack.png&quot;</span>)`}}),{c(){r=n("p"),v=i("To load a textual inversion embedding vector in "),d=n("code"),f=i("diffusers"),$=i(" format:"),p=h(),w(b.$$.fragment)},l(m){r=a(m,"P",{});var _=s(r);v=l(_,"To load a textual inversion embedding vector in "),d=a(_,"CODE",{});var C=s(d);f=l(C,"diffusers"),C.forEach(t),$=l(_," format:"),_.forEach(t),p=u(m),y(b.$$.fragment,m)},m(m,_){x(m,r,_),e(r,v),e(r,d),e(d,f),e(r,$),x(m,p,_),k(b,m,_),T=!0},p:Qr,i(m){T||(L(b.$$.fragment,m),T=!0)},o(m){M(b.$$.fragment,m),T=!1},d(m){m&&t(r),m&&t(p),E(b,m)}}}function Kn(D){let r,v,d,f,$,p,b,T;return b=new Yr({props:{code:`from diffusers import StableDiffusionPipeline
import torch

model_id = "runwayml/stable-diffusion-v1-5"
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

pipe.load_textual_inversion("./charturnerv2.pt", token="charturnerv2")

prompt = "charturnerv2, multiple views of the same character in the same outfit, a character turnaround of a woman wearing a black jacket and red shirt, best quality, intricate details."

image = pipe(prompt, num_inference_steps=50).images[0]
image.save("character.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

model_id = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.load_textual_inversion(<span class="hljs-string">&quot;./charturnerv2.pt&quot;</span>, token=<span class="hljs-string">&quot;charturnerv2&quot;</span>)

prompt = <span class="hljs-string">&quot;charturnerv2, multiple views of the same character in the same outfit, a character turnaround of a woman wearing a black jacket and red shirt, best quality, intricate details.&quot;</span>

image = pipe(prompt, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;character.png&quot;</span>)`}}),{c(){r=n("p"),v=i("e.g. from "),d=n("a"),f=i("civitAI"),$=i(" and then load the vector locally:"),p=h(),w(b.$$.fragment),this.h()},l(m){r=a(m,"P",{});var _=s(r);v=l(_,"e.g. from "),d=a(_,"A",{href:!0,rel:!0});var C=s(d);f=l(C,"civitAI"),C.forEach(t),$=l(_," and then load the vector locally:"),_.forEach(t),p=u(m),y(b.$$.fragment,m),this.h()},h(){c(d,"href","https://civitai.com/models/3036?modelVersionId=9857"),c(d,"rel","nofollow")},m(m,_){x(m,r,_),e(r,v),e(r,d),e(d,f),e(r,$),x(m,p,_),k(b,m,_),T=!0},p:Qr,i(m){T||(L(b.$$.fragment,m),T=!0)},o(m){M(b.$$.fragment,m),T=!1},d(m){m&&t(r),m&&t(p),E(b,m)}}}function Qn(D){let r,v;return{c(){r=n("p"),v=i("This function is experimental and might change in the future.")},l(d){r=a(d,"P",{});var f=s(r);v=l(f,"This function is experimental and might change in the future."),f.forEach(t)},m(d,f){x(d,r,f),e(r,v)},d(d){d&&t(r)}}}function Yn(D){let r,v;return{c(){r=n("p"),v=i("This function is experimental and might change in the future.")},l(d){r=a(d,"P",{});var f=s(r);v=l(f,"This function is experimental and might change in the future."),f.forEach(t)},m(d,f){x(d,r,f),e(r,v)},d(d){d&&t(r)}}}function Zn(D){let r,v,d,f,$,p,b,T;return{c(){r=n("p"),v=i("It is required to be logged in ("),d=n("code"),f=i("huggingface-cli login"),$=i(") when you want to use private or "),p=n("a"),b=i(`gated
models`),T=i("."),this.h()},l(m){r=a(m,"P",{});var _=s(r);v=l(_,"It is required to be logged in ("),d=a(_,"CODE",{});var C=s(d);f=l(C,"huggingface-cli login"),C.forEach(t),$=l(_,") when you want to use private or "),p=a(_,"A",{href:!0,rel:!0});var N=s(p);b=l(N,`gated
models`),N.forEach(t),T=l(_,"."),_.forEach(t),this.h()},h(){c(p,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),c(p,"rel","nofollow")},m(m,_){x(m,r,_),e(r,v),e(r,d),e(d,f),e(r,$),e(r,p),e(p,b),e(r,T)},d(m){m&&t(r)}}}function ea(D){let r,v,d,f,$;return f=new Yr({props:{code:`from diffusers import StableDiffusionPipeline

# Download pipeline from huggingface.co and cache.
pipeline = StableDiffusionPipeline.from_ckpt(
    "https://huggingface.co/WarriorMama777/OrangeMixs/blob/main/Models/AbyssOrangeMix/AbyssOrangeMix.safetensors"
)

# Download pipeline from local file
# file is downloaded under ./v1-5-pruned-emaonly.ckpt
pipeline = StableDiffusionPipeline.from_ckpt("./v1-5-pruned-emaonly")

# Enable float16 and move to GPU
pipeline = StableDiffusionPipeline.from_ckpt(
    "https://huggingface.co/runwayml/stable-diffusion-v1-5/blob/main/v1-5-pruned-emaonly.ckpt",
    torch_dtype=torch.float16,
)
pipeline.to("cuda")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download pipeline from huggingface.co and cache.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = StableDiffusionPipeline.from_ckpt(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://huggingface.co/WarriorMama777/OrangeMixs/blob/main/Models/AbyssOrangeMix/AbyssOrangeMix.safetensors&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download pipeline from local file</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># file is downloaded under ./v1-5-pruned-emaonly.ckpt</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = StableDiffusionPipeline.from_ckpt(<span class="hljs-string">&quot;./v1-5-pruned-emaonly&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Enable float16 and move to GPU</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = StableDiffusionPipeline.from_ckpt(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://huggingface.co/runwayml/stable-diffusion-v1-5/blob/main/v1-5-pruned-emaonly.ckpt&quot;</span>,
<span class="hljs-meta">... </span>    torch_dtype=torch.float16,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.to(<span class="hljs-string">&quot;cuda&quot;</span>)`}}),{c(){r=n("p"),v=i("Examples:"),d=h(),w(f.$$.fragment)},l(p){r=a(p,"P",{});var b=s(r);v=l(b,"Examples:"),b.forEach(t),d=u(p),y(f.$$.fragment,p)},m(p,b){x(p,r,b),e(r,v),x(p,d,b),k(f,p,b),$=!0},p:Qr,i(p){$||(L(f.$$.fragment,p),$=!0)},o(p){M(f.$$.fragment,p),$=!1},d(p){p&&t(r),p&&t(d),E(f,p)}}}function oa(D){let r,v,d,f,$,p,b,T,m,_,C,N,Bo,V,io,Qe,gt,_t,lo,Le,vt,xt,co,Me,bt,Go,ee,$t,oe,po,wt,yt,kt,Xo,Ee,fo,Lt,Mt,Jo,H,te,ho,Te,Et,uo,Tt,Ko,B,re,mo,De,Dt,go,Ct,Qo,j,Ce,Pt,U,Pe,It,O,At,_o,qt,Nt,Ie,vo,Ut,St,xo,Ft,jt,Ot,ne,Wt,ae,zt,se,Ae,Vt,qe,Rt,Ye,Ht,Bt,Yo,G,ie,bo,Ne,Gt,$o,Xt,Zo,q,Ue,Jt,wo,Kt,Qt,P,Se,Yt,X,Zt,yo,er,or,ko,tr,rr,nr,le,ar,de,sr,Lo,ir,lr,ce,dr,Mo,cr,pr,pe,fr,fe,Fe,hr,Eo,ur,et,J,he,To,je,mr,Do,gr,ot,A,Oe,_r,K,vr,Ze,xr,br,We,Co,$r,wr,yr,ue,kr,S,ze,Lr,Q,Mr,eo,Er,Tr,Ve,Po,Dr,Cr,Pr,me,Ir,ge,Ar,_e,Re,qr,Io,Nr,tt,Y,ve,Ao,He,Ur,qo,Sr,rt,W,Be,Fr,No,jr,Or,F,Ge,Wr,Uo,zr,Vr,Xe,Rr,So,Hr,Br,Gr,xe,nt;return p=new so({}),Te=new so({}),De=new so({}),Ce=new z({props:{name:"class diffusers.loaders.UNet2DConditionLoadersMixin",anchor:"diffusers.loaders.UNet2DConditionLoadersMixin",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_3274/src/diffusers/loaders.py#L92"}}),Pe=new z({props:{name:"load_attn_procs",anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs",parameters:[{name:"pretrained_model_name_or_path_or_dict",val:": typing.Union[str, typing.Dict[str, torch.Tensor]]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs.pretrained_model_name_or_path_or_dict",description:`<strong>pretrained_model_name_or_path_or_dict</strong> (<code>str</code> or <code>os.PathLike</code> or <code>dict</code>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a pretrained model hosted inside a model repo on huggingface.co.
Valid model ids should have an organization name, like <code>google/ddpm-celebahq-256</code>.</li>
<li>A path to a <em>directory</em> containing model weights saved using <code>~ModelMixin.save_config</code>, e.g.,
<code>./my_model_directory/</code>.</li>
<li>A <a href="https://pytorch.org/tutorials/beginner/saving_loading_models.html#what-is-a-state-dict" rel="nofollow">torch state
dict</a>.</li>
</ul>`,name:"pretrained_model_name_or_path_or_dict"},{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>diffusers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo (either remote in
huggingface.co or downloaded locally), you can specify the folder name here.`,name:"subfolder"},{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information.`,name:"mirror"}],source:"https://github.com/huggingface/diffusers/blob/vr_3274/src/diffusers/loaders.py#L96"}}),ne=new Ke({props:{warning:!0,$$slots:{default:[Hn]},$$scope:{ctx:D}}}),ae=new Ke({props:{$$slots:{default:[Bn]},$$scope:{ctx:D}}}),Ae=new z({props:{name:"save_attn_procs",anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.save_attn_procs",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"is_main_process",val:": bool = True"},{name:"weight_name",val:": str = None"},{name:"save_function",val:": typing.Callable = None"},{name:"safe_serialization",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.save_attn_procs.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory to which to save. Will be created if it doesn&#x2019;t exist.`,name:"save_directory"},{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.save_attn_procs.is_main_process",description:`<strong>is_main_process</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether the process calling this is the main process or not. Useful when in distributed training like
TPUs and need to call this function on all processes. In this case, set <code>is_main_process=True</code> only on
the main process to avoid race conditions.`,name:"is_main_process"},{anchor:"diffusers.loaders.UNet2DConditionLoadersMixin.save_attn_procs.save_function",description:`<strong>save_function</strong> (<code>Callable</code>) &#x2014;
The function to use to save the state dictionary. Useful on distributed training like TPUs when one
need to replace <code>torch.save</code> by another method. Can be configured with the environment variable
<code>DIFFUSERS_SAVE_MODE</code>.`,name:"save_function"}],source:"https://github.com/huggingface/diffusers/blob/vr_3274/src/diffusers/loaders.py#L299"}}),Ne=new so({}),Ue=new z({props:{name:"class diffusers.loaders.TextualInversionLoaderMixin",anchor:"diffusers.loaders.TextualInversionLoaderMixin",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_3274/src/diffusers/loaders.py#L376"}}),Se=new z({props:{name:"load_textual_inversion",anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, typing.Dict[str, torch.Tensor]]"},{name:"token",val:": typing.Optional[str] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a pretrained model hosted inside a model repo on huggingface.co.
Valid model ids should have an organization name, like
<code>&quot;sd-concepts-library/low-poly-hd-logos-icons&quot;</code>.</li>
<li>A path to a <em>directory</em> containing textual inversion weights, e.g.
<code>./my_text_inversion_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.weight_name",description:`<strong>weight_name</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Name of a custom weight file. This should be used in two cases:</p>
<ul>
<li>The saved textual inversion file is in <code>diffusers</code> format, but was saved under a specific weight
name, such as <code>text_inv.bin</code>.</li>
<li>The saved textual inversion file is in the &#x201C;Automatic1111&#x201D; form.</li>
</ul>`,name:"weight_name"},{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>diffusers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo (either remote in
huggingface.co or downloaded locally), you can specify the folder name here.`,name:"subfolder"},{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information.`,name:"mirror"}],source:"https://github.com/huggingface/diffusers/blob/vr_3274/src/diffusers/loaders.py#L438"}}),le=new Ke({props:{warning:!0,$$slots:{default:[Gn]},$$scope:{ctx:D}}}),de=new Ke({props:{$$slots:{default:[Xn]},$$scope:{ctx:D}}}),ce=new Kr({props:{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.example",$$slots:{default:[Jn]},$$scope:{ctx:D}}}),pe=new Kr({props:{anchor:"diffusers.loaders.TextualInversionLoaderMixin.load_textual_inversion.example-2",$$slots:{default:[Kn]},$$scope:{ctx:D}}}),Fe=new z({props:{name:"maybe_convert_prompt",anchor:"diffusers.loaders.TextualInversionLoaderMixin.maybe_convert_prompt",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]]"},{name:"tokenizer",val:": PreTrainedTokenizer"}],parametersDescription:[{anchor:"diffusers.loaders.TextualInversionLoaderMixin.maybe_convert_prompt.prompt",description:`<strong>prompt</strong> (<code>str</code> or list of <code>str</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt"},{anchor:"diffusers.loaders.TextualInversionLoaderMixin.maybe_convert_prompt.tokenizer",description:`<strong>tokenizer</strong> (<code>PreTrainedTokenizer</code>) &#x2014;
The tokenizer responsible for encoding the prompt into input tokens.`,name:"tokenizer"}],source:"https://github.com/huggingface/diffusers/blob/vr_3274/src/diffusers/loaders.py#L381",returnDescription:`
<p>The converted prompt</p>
`,returnType:`
<p><code>str</code> or list of <code>str</code></p>
`}}),je=new so({}),Oe=new z({props:{name:"class diffusers.loaders.LoraLoaderMixin",anchor:"diffusers.loaders.LoraLoaderMixin",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_3274/src/diffusers/loaders.py#L682"}}),ue=new Ke({props:{warning:!0,$$slots:{default:[Qn]},$$scope:{ctx:D}}}),ze=new z({props:{name:"load_lora_weights",anchor:"diffusers.loaders.LoraLoaderMixin.load_lora_weights",parameters:[{name:"pretrained_model_name_or_path_or_dict",val:": typing.Union[str, typing.Dict[str, torch.Tensor]]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.loaders.LoraLoaderMixin.load_lora_weights.pretrained_model_name_or_path_or_dict",description:`<strong>pretrained_model_name_or_path_or_dict</strong> (<code>str</code> or <code>os.PathLike</code> or <code>dict</code>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a pretrained model hosted inside a model repo on huggingface.co.
Valid model ids should have an organization name, like <code>google/ddpm-celebahq-256</code>.</li>
<li>A path to a <em>directory</em> containing model weights saved using <code>~ModelMixin.save_config</code>, e.g.,
<code>./my_model_directory/</code>.</li>
<li>A <a href="https://pytorch.org/tutorials/beginner/saving_loading_models.html#what-is-a-state-dict" rel="nofollow">torch state
dict</a>.</li>
</ul>`,name:"pretrained_model_name_or_path_or_dict"},{anchor:"diffusers.loaders.LoraLoaderMixin.load_lora_weights.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.loaders.LoraLoaderMixin.load_lora_weights.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.loaders.LoraLoaderMixin.load_lora_weights.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.loaders.LoraLoaderMixin.load_lora_weights.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.loaders.LoraLoaderMixin.load_lora_weights.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.loaders.LoraLoaderMixin.load_lora_weights.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>diffusers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.loaders.LoraLoaderMixin.load_lora_weights.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.loaders.LoraLoaderMixin.load_lora_weights.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo (either remote in
huggingface.co or downloaded locally), you can specify the folder name here.`,name:"subfolder"},{anchor:"diffusers.loaders.LoraLoaderMixin.load_lora_weights.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information.`,name:"mirror"}],source:"https://github.com/huggingface/diffusers/blob/vr_3274/src/diffusers/loaders.py#L696"}}),me=new Ke({props:{warning:!0,$$slots:{default:[Yn]},$$scope:{ctx:D}}}),ge=new Ke({props:{$$slots:{default:[Zn]},$$scope:{ctx:D}}}),Re=new z({props:{name:"save_lora_weights",anchor:"diffusers.loaders.LoraLoaderMixin.save_lora_weights",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"unet_lora_layers",val:": typing.Dict[str, torch.nn.modules.module.Module] = None"},{name:"text_encoder_lora_layers",val:": typing.Dict[str, torch.nn.modules.module.Module] = None"},{name:"is_main_process",val:": bool = True"},{name:"weight_name",val:": str = None"},{name:"save_function",val:": typing.Callable = None"},{name:"safe_serialization",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.loaders.LoraLoaderMixin.save_lora_weights.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory to which to save. Will be created if it doesn&#x2019;t exist.`,name:"save_directory"},{anchor:"diffusers.loaders.LoraLoaderMixin.save_lora_weights.unet_lora_layers",description:`<strong>unet_lora_layers</strong> (<code>Dict[str, torch.nn.Module</code>]) &#x2014;
State dict of the LoRA layers corresponding to the UNet. Specifying this helps to make the
serialization process easier and cleaner.`,name:"unet_lora_layers"},{anchor:"diffusers.loaders.LoraLoaderMixin.save_lora_weights.text_encoder_lora_layers",description:`<strong>text_encoder_lora_layers</strong> (<code>Dict[str, torch.nn.Module</code>]) &#x2014;
State dict of the LoRA layers corresponding to the <code>text_encoder</code>. Since the <code>text_encoder</code> comes from
<code>transformers</code>, we cannot rejig it. That is why we have to explicitly pass the text encoder LoRA state
dict.`,name:"text_encoder_lora_layers"},{anchor:"diffusers.loaders.LoraLoaderMixin.save_lora_weights.is_main_process",description:`<strong>is_main_process</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether the process calling this is the main process or not. Useful when in distributed training like
TPUs and need to call this function on all processes. In this case, set <code>is_main_process=True</code> only on
the main process to avoid race conditions.`,name:"is_main_process"},{anchor:"diffusers.loaders.LoraLoaderMixin.save_lora_weights.save_function",description:`<strong>save_function</strong> (<code>Callable</code>) &#x2014;
The function to use to save the state dictionary. Useful on distributed training like TPUs when one
need to replace <code>torch.save</code> by another method. Can be configured with the environment variable
<code>DIFFUSERS_SAVE_MODE</code>.`,name:"save_function"}],source:"https://github.com/huggingface/diffusers/blob/vr_3274/src/diffusers/loaders.py#L1058"}}),He=new so({}),Be=new z({props:{name:"class diffusers.loaders.FromCkptMixin",anchor:"diffusers.loaders.FromCkptMixin",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_3274/src/diffusers/loaders.py#L1132"}}),Ge=new z({props:{name:"from_ckpt",anchor:"diffusers.loaders.FromCkptMixin.from_ckpt",parameters:[{name:"pretrained_model_link_or_path",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.pretrained_model_link_or_path",description:`<strong>pretrained_model_link_or_path</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Can be either:<ul>
<li>A link to the .ckpt file on the Hub. Should be in the format
<code>&quot;https://huggingface.co/&lt;repo_id&gt;/blob/main/&lt;path_to_file&gt;&quot;</code></li>
<li>A path to a <em>file</em> containing all pipeline weights.</li>
</ul>`,name:"pretrained_model_link_or_path"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.torch_dtype",description:`<strong>torch_dtype</strong> (<code>str</code> or <code>torch.dtype</code>, <em>optional</em>) &#x2014;
Override the default <code>torch.dtype</code> and load the model under this dtype. If <code>&quot;auto&quot;</code> is passed the dtype
will be automatically derived from the model&#x2019;s weights.`,name:"torch_dtype"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.local_files_only",description:`<strong>local_files_only</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>huggingface-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.use_safetensors",description:`<strong>use_safetensors</strong> (<code>bool</code>, <em>optional</em> ) &#x2014;
If set to <code>True</code>, the pipeline will be loaded from <code>safetensors</code> weights. If set to <code>None</code> (the
default). The pipeline will load using <code>safetensors</code> if the safetensors weights are available <em>and</em> if
<code>safetensors</code> is installed. If the to <code>False</code> the pipeline will <em>not</em> use <code>safetensors</code>.`,name:"use_safetensors"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.extract_ema",description:`<strong>extract_ema</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014; Only relevant for
checkpoints that have both EMA and non-EMA weights. Whether to extract the EMA weights or not. Defaults
to <code>False</code>. Pass <code>True</code> to extract the EMA weights. EMA weights usually yield higher quality images for
inference. Non-EMA weights are usually better to continue fine-tuning.`,name:"extract_ema"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.upcast_attention",description:`<strong>upcast_attention</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Whether the attention computation should always be upcasted. This is necessary when running stable`,name:"upcast_attention"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.image_size",description:`<strong>image_size</strong> (<code>int</code>, <em>optional</em>, defaults to 512) &#x2014;
The image size that the model was trained on. Use 512 for Stable Diffusion v1.X and Stable Diffusion v2
Base. Use 768 for Stable Diffusion v2.`,name:"image_size"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The prediction type that the model was trained on. Use <code>&apos;epsilon&apos;</code> for Stable Diffusion v1.X and Stable
Diffusion v2 Base. Use <code>&apos;v_prediction&apos;</code> for Stable Diffusion v2.`,name:"prediction_type"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.num_in_channels",description:`<strong>num_in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to None) &#x2014;
The number of input channels. If <code>None</code>, it will be automatically inferred.`,name:"num_in_channels"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.scheduler_type",description:`<strong>scheduler_type</strong> (<code>str</code>, <em>optional</em>, defaults to &#x2018;pndm&#x2019;) &#x2014;
Type of scheduler to use. Should be one of <code>[&quot;pndm&quot;, &quot;lms&quot;, &quot;heun&quot;, &quot;euler&quot;, &quot;euler-ancestral&quot;, &quot;dpm&quot;, &quot;ddim&quot;]</code>.`,name:"scheduler_type"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.load_safety_checker",description:`<strong>load_safety_checker</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to load the safety checker or not. Defaults to <code>True</code>.`,name:"load_safety_checker"},{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.kwargs",description:`<strong>kwargs</strong> (remaining dictionary of keyword arguments, <em>optional</em>) &#x2014;
Can be used to overwrite load - and saveable variables - <em>i.e.</em> the pipeline components - of the
specific pipeline class. The overwritten components are then directly passed to the pipelines
<code>__init__</code> method. See example below for more information.`,name:"kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_3274/src/diffusers/loaders.py#L1136"}}),xe=new Kr({props:{anchor:"diffusers.loaders.FromCkptMixin.from_ckpt.example",$$slots:{default:[ea]},$$scope:{ctx:D}}}),{c(){r=n("meta"),v=h(),d=n("h1"),f=n("a"),$=n("span"),w(p.$$.fragment),b=h(),T=n("span"),m=i("Loaders"),_=h(),C=n("p"),N=i("There are many ways to train adapter neural networks for diffusion models, such as"),Bo=h(),V=n("ul"),io=n("li"),Qe=n("a"),gt=i("Textual Inversion"),_t=h(),lo=n("li"),Le=n("a"),vt=i("LoRA"),xt=h(),co=n("li"),Me=n("a"),bt=i("Hypernetworks"),Go=h(),ee=n("p"),$t=i(`Such adapter neural networks often only consist of a fraction of the number of weights compared
to the pretrained model and as such are very portable. The Diffusers library offers an easy-to-use
API to load such adapter neural networks via the `),oe=n("a"),po=n("code"),wt=i("loaders.py"),yt=i(" module"),kt=i("."),Xo=h(),Ee=n("p"),fo=n("strong"),Lt=i("Note"),Mt=i(": This module is still highly experimental and prone to future changes."),Jo=h(),H=n("h2"),te=n("a"),ho=n("span"),w(Te.$$.fragment),Et=h(),uo=n("span"),Tt=i("LoaderMixins"),Ko=h(),B=n("h3"),re=n("a"),mo=n("span"),w(De.$$.fragment),Dt=h(),go=n("span"),Ct=i("UNet2DConditionLoadersMixin"),Qo=h(),j=n("div"),w(Ce.$$.fragment),Pt=h(),U=n("div"),w(Pe.$$.fragment),It=h(),O=n("p"),At=i("Load pretrained attention processor layers into "),_o=n("code"),qt=i("UNet2DConditionModel"),Nt=i(`. Attention processor layers have to be
defined in
`),Ie=n("a"),vo=n("code"),Ut=i("cross_attention.py"),St=i(`
and be a `),xo=n("code"),Ft=i("torch.nn.Module"),jt=i(" class."),Ot=h(),w(ne.$$.fragment),Wt=h(),w(ae.$$.fragment),zt=h(),se=n("div"),w(Ae.$$.fragment),Vt=h(),qe=n("p"),Rt=i(`Save an attention processor to a directory, so that it can be re-loaded using the
`),Ye=n("a"),Ht=i("load_attn_procs()"),Bt=i(" method."),Yo=h(),G=n("h3"),ie=n("a"),bo=n("span"),w(Ne.$$.fragment),Gt=h(),$o=n("span"),Xt=i("TextualInversionLoaderMixin"),Zo=h(),q=n("div"),w(Ue.$$.fragment),Jt=h(),wo=n("p"),Kt=i("Mixin class for loading textual inversion tokens and embeddings to the tokenizer and text encoder."),Qt=h(),P=n("div"),w(Se.$$.fragment),Yt=h(),X=n("p"),Zt=i("Load textual inversion embeddings into the text encoder of stable diffusion pipelines. Both "),yo=n("code"),er=i("diffusers"),or=i(` and
`),ko=n("code"),tr=i("Automatic1111"),rr=i(" formats are supported (see example below)."),nr=h(),w(le.$$.fragment),ar=h(),w(de.$$.fragment),sr=h(),Lo=n("p"),ir=i("Example:"),lr=h(),w(ce.$$.fragment),dr=h(),Mo=n("p"),cr=i("To load a textual inversion embedding vector in Automatic1111 format, make sure to first download the vector,"),pr=h(),w(pe.$$.fragment),fr=h(),fe=n("div"),w(Fe.$$.fragment),hr=h(),Eo=n("p"),ur=i(`Maybe convert a prompt into a \u201Cmulti vector\u201D-compatible prompt. If the prompt includes a token that corresponds
to a multi-vector textual inversion embedding, this function will process the prompt so that the special token
is replaced with multiple special tokens each corresponding to one of the vectors. If the prompt has no textual
inversion token or a textual inversion token that is a single vector, the input prompt is simply returned.`),et=h(),J=n("h3"),he=n("a"),To=n("span"),w(je.$$.fragment),mr=h(),Do=n("span"),gr=i("LoraLoaderMixin"),ot=h(),A=n("div"),w(Oe.$$.fragment),_r=h(),K=n("p"),vr=i("Utility class for handling the loading LoRA layers into UNet (of class "),Ze=n("a"),xr=i("UNet2DConditionModel"),br=i(`) and Text Encoder
(of class `),We=n("a"),Co=n("code"),$r=i("CLIPTextModel"),wr=i(")."),yr=h(),w(ue.$$.fragment),kr=h(),S=n("div"),w(ze.$$.fragment),Lr=h(),Q=n("p"),Mr=i("Load pretrained attention processor layers (such as LoRA) into "),eo=n("a"),Er=i("UNet2DConditionModel"),Tr=i(` and
`),Ve=n("a"),Po=n("code"),Dr=i("CLIPTextModel"),Cr=i(")."),Pr=h(),w(me.$$.fragment),Ir=h(),w(ge.$$.fragment),Ar=h(),_e=n("div"),w(Re.$$.fragment),qr=h(),Io=n("p"),Nr=i("Save the LoRA parameters corresponding to the UNet and the text encoder."),tt=h(),Y=n("h3"),ve=n("a"),Ao=n("span"),w(He.$$.fragment),Ur=h(),qo=n("span"),Sr=i("FromCkptMixin"),rt=h(),W=n("div"),w(Be.$$.fragment),Fr=h(),No=n("p"),jr=i(`This helper class allows to directly load .ckpt stable diffusion file_extension
into the respective classes.`),Or=h(),F=n("div"),w(Ge.$$.fragment),Wr=h(),Uo=n("p"),zr=i("Instantiate a PyTorch diffusion pipeline from pre-trained pipeline weights saved in the original .ckpt format."),Vr=h(),Xe=n("p"),Rr=i("The pipeline is set in evaluation mode by default using "),So=n("code"),Hr=i("model.eval()"),Br=i(" (Dropout modules are deactivated)."),Gr=h(),w(xe.$$.fragment),this.h()},l(o){const g=Vn('[data-svelte="svelte-1phssyn"]',document.head);r=a(g,"META",{name:!0,content:!0}),g.forEach(t),v=u(o),d=a(o,"H1",{class:!0});var Je=s(d);f=a(Je,"A",{id:!0,class:!0,href:!0});var Fo=s(f);$=a(Fo,"SPAN",{});var jo=s($);y(p.$$.fragment,jo),jo.forEach(t),Fo.forEach(t),b=u(Je),T=a(Je,"SPAN",{});var Oo=s(T);m=l(Oo,"Loaders"),Oo.forEach(t),Je.forEach(t),_=u(o),C=a(o,"P",{});var Wo=s(C);N=l(Wo,"There are many ways to train adapter neural networks for diffusion models, such as"),Wo.forEach(t),Bo=u(o),V=a(o,"UL",{});var Z=s(V);io=a(Z,"LI",{});var zo=s(io);Qe=a(zo,"A",{href:!0});var Vo=s(Qe);gt=l(Vo,"Textual Inversion"),Vo.forEach(t),zo.forEach(t),_t=u(Z),lo=a(Z,"LI",{});var Ro=s(lo);Le=a(Ro,"A",{href:!0,rel:!0});var Ho=s(Le);vt=l(Ho,"LoRA"),Ho.forEach(t),Ro.forEach(t),xt=u(Z),co=a(Z,"LI",{});var Zr=s(co);Me=a(Zr,"A",{href:!0,rel:!0});var en=s(Me);bt=l(en,"Hypernetworks"),en.forEach(t),Zr.forEach(t),Z.forEach(t),Go=u(o),ee=a(o,"P",{});var at=s(ee);$t=l(at,`Such adapter neural networks often only consist of a fraction of the number of weights compared
to the pretrained model and as such are very portable. The Diffusers library offers an easy-to-use
API to load such adapter neural networks via the `),oe=a(at,"A",{href:!0,rel:!0});var Xr=s(oe);po=a(Xr,"CODE",{});var on=s(po);wt=l(on,"loaders.py"),on.forEach(t),yt=l(Xr," module"),Xr.forEach(t),kt=l(at,"."),at.forEach(t),Xo=u(o),Ee=a(o,"P",{});var Jr=s(Ee);fo=a(Jr,"STRONG",{});var tn=s(fo);Lt=l(tn,"Note"),tn.forEach(t),Mt=l(Jr,": This module is still highly experimental and prone to future changes."),Jr.forEach(t),Jo=u(o),H=a(o,"H2",{class:!0});var st=s(H);te=a(st,"A",{id:!0,class:!0,href:!0});var rn=s(te);ho=a(rn,"SPAN",{});var nn=s(ho);y(Te.$$.fragment,nn),nn.forEach(t),rn.forEach(t),Et=u(st),uo=a(st,"SPAN",{});var an=s(uo);Tt=l(an,"LoaderMixins"),an.forEach(t),st.forEach(t),Ko=u(o),B=a(o,"H3",{class:!0});var it=s(B);re=a(it,"A",{id:!0,class:!0,href:!0});var sn=s(re);mo=a(sn,"SPAN",{});var ln=s(mo);y(De.$$.fragment,ln),ln.forEach(t),sn.forEach(t),Dt=u(it),go=a(it,"SPAN",{});var dn=s(go);Ct=l(dn,"UNet2DConditionLoadersMixin"),dn.forEach(t),it.forEach(t),Qo=u(o),j=a(o,"DIV",{class:!0});var oo=s(j);y(Ce.$$.fragment,oo),Pt=u(oo),U=a(oo,"DIV",{class:!0});var be=s(U);y(Pe.$$.fragment,be),It=u(be),O=a(be,"P",{});var $e=s(O);At=l($e,"Load pretrained attention processor layers into "),_o=a($e,"CODE",{});var cn=s(_o);qt=l(cn,"UNet2DConditionModel"),cn.forEach(t),Nt=l($e,`. Attention processor layers have to be
defined in
`),Ie=a($e,"A",{href:!0,rel:!0});var pn=s(Ie);vo=a(pn,"CODE",{});var fn=s(vo);Ut=l(fn,"cross_attention.py"),fn.forEach(t),pn.forEach(t),St=l($e,`
and be a `),xo=a($e,"CODE",{});var hn=s(xo);Ft=l(hn,"torch.nn.Module"),hn.forEach(t),jt=l($e," class."),$e.forEach(t),Ot=u(be),y(ne.$$.fragment,be),Wt=u(be),y(ae.$$.fragment,be),be.forEach(t),zt=u(oo),se=a(oo,"DIV",{class:!0});var lt=s(se);y(Ae.$$.fragment,lt),Vt=u(lt),qe=a(lt,"P",{});var dt=s(qe);Rt=l(dt,`Save an attention processor to a directory, so that it can be re-loaded using the
`),Ye=a(dt,"A",{href:!0});var un=s(Ye);Ht=l(un,"load_attn_procs()"),un.forEach(t),Bt=l(dt," method."),dt.forEach(t),lt.forEach(t),oo.forEach(t),Yo=u(o),G=a(o,"H3",{class:!0});var ct=s(G);ie=a(ct,"A",{id:!0,class:!0,href:!0});var mn=s(ie);bo=a(mn,"SPAN",{});var gn=s(bo);y(Ne.$$.fragment,gn),gn.forEach(t),mn.forEach(t),Gt=u(ct),$o=a(ct,"SPAN",{});var _n=s($o);Xt=l(_n,"TextualInversionLoaderMixin"),_n.forEach(t),ct.forEach(t),Zo=u(o),q=a(o,"DIV",{class:!0});var we=s(q);y(Ue.$$.fragment,we),Jt=u(we),wo=a(we,"P",{});var vn=s(wo);Kt=l(vn,"Mixin class for loading textual inversion tokens and embeddings to the tokenizer and text encoder."),vn.forEach(t),Qt=u(we),P=a(we,"DIV",{class:!0});var I=s(P);y(Se.$$.fragment,I),Yt=u(I),X=a(I,"P",{});var to=s(X);Zt=l(to,"Load textual inversion embeddings into the text encoder of stable diffusion pipelines. Both "),yo=a(to,"CODE",{});var xn=s(yo);er=l(xn,"diffusers"),xn.forEach(t),or=l(to,` and
`),ko=a(to,"CODE",{});var bn=s(ko);tr=l(bn,"Automatic1111"),bn.forEach(t),rr=l(to," formats are supported (see example below)."),to.forEach(t),nr=u(I),y(le.$$.fragment,I),ar=u(I),y(de.$$.fragment,I),sr=u(I),Lo=a(I,"P",{});var $n=s(Lo);ir=l($n,"Example:"),$n.forEach(t),lr=u(I),y(ce.$$.fragment,I),dr=u(I),Mo=a(I,"P",{});var wn=s(Mo);cr=l(wn,"To load a textual inversion embedding vector in Automatic1111 format, make sure to first download the vector,"),wn.forEach(t),pr=u(I),y(pe.$$.fragment,I),I.forEach(t),fr=u(we),fe=a(we,"DIV",{class:!0});var pt=s(fe);y(Fe.$$.fragment,pt),hr=u(pt),Eo=a(pt,"P",{});var yn=s(Eo);ur=l(yn,`Maybe convert a prompt into a \u201Cmulti vector\u201D-compatible prompt. If the prompt includes a token that corresponds
to a multi-vector textual inversion embedding, this function will process the prompt so that the special token
is replaced with multiple special tokens each corresponding to one of the vectors. If the prompt has no textual
inversion token or a textual inversion token that is a single vector, the input prompt is simply returned.`),yn.forEach(t),pt.forEach(t),we.forEach(t),et=u(o),J=a(o,"H3",{class:!0});var ft=s(J);he=a(ft,"A",{id:!0,class:!0,href:!0});var kn=s(he);To=a(kn,"SPAN",{});var Ln=s(To);y(je.$$.fragment,Ln),Ln.forEach(t),kn.forEach(t),mr=u(ft),Do=a(ft,"SPAN",{});var Mn=s(Do);gr=l(Mn,"LoraLoaderMixin"),Mn.forEach(t),ft.forEach(t),ot=u(o),A=a(o,"DIV",{class:!0});var R=s(A);y(Oe.$$.fragment,R),_r=u(R),K=a(R,"P",{});var ro=s(K);vr=l(ro,"Utility class for handling the loading LoRA layers into UNet (of class "),Ze=a(ro,"A",{href:!0});var En=s(Ze);xr=l(En,"UNet2DConditionModel"),En.forEach(t),br=l(ro,`) and Text Encoder
(of class `),We=a(ro,"A",{href:!0,rel:!0});var Tn=s(We);Co=a(Tn,"CODE",{});var Dn=s(Co);$r=l(Dn,"CLIPTextModel"),Dn.forEach(t),Tn.forEach(t),wr=l(ro,")."),ro.forEach(t),yr=u(R),y(ue.$$.fragment,R),kr=u(R),S=a(R,"DIV",{class:!0});var ye=s(S);y(ze.$$.fragment,ye),Lr=u(ye),Q=a(ye,"P",{});var no=s(Q);Mr=l(no,"Load pretrained attention processor layers (such as LoRA) into "),eo=a(no,"A",{href:!0});var Cn=s(eo);Er=l(Cn,"UNet2DConditionModel"),Cn.forEach(t),Tr=l(no,` and
`),Ve=a(no,"A",{href:!0,rel:!0});var Pn=s(Ve);Po=a(Pn,"CODE",{});var In=s(Po);Dr=l(In,"CLIPTextModel"),In.forEach(t),Pn.forEach(t),Cr=l(no,")."),no.forEach(t),Pr=u(ye),y(me.$$.fragment,ye),Ir=u(ye),y(ge.$$.fragment,ye),ye.forEach(t),Ar=u(R),_e=a(R,"DIV",{class:!0});var ht=s(_e);y(Re.$$.fragment,ht),qr=u(ht),Io=a(ht,"P",{});var An=s(Io);Nr=l(An,"Save the LoRA parameters corresponding to the UNet and the text encoder."),An.forEach(t),ht.forEach(t),R.forEach(t),tt=u(o),Y=a(o,"H3",{class:!0});var ut=s(Y);ve=a(ut,"A",{id:!0,class:!0,href:!0});var qn=s(ve);Ao=a(qn,"SPAN",{});var Nn=s(Ao);y(He.$$.fragment,Nn),Nn.forEach(t),qn.forEach(t),Ur=u(ut),qo=a(ut,"SPAN",{});var Un=s(qo);Sr=l(Un,"FromCkptMixin"),Un.forEach(t),ut.forEach(t),rt=u(o),W=a(o,"DIV",{class:!0});var ao=s(W);y(Be.$$.fragment,ao),Fr=u(ao),No=a(ao,"P",{});var Sn=s(No);jr=l(Sn,`This helper class allows to directly load .ckpt stable diffusion file_extension
into the respective classes.`),Sn.forEach(t),Or=u(ao),F=a(ao,"DIV",{class:!0});var ke=s(F);y(Ge.$$.fragment,ke),Wr=u(ke),Uo=a(ke,"P",{});var Fn=s(Uo);zr=l(Fn,"Instantiate a PyTorch diffusion pipeline from pre-trained pipeline weights saved in the original .ckpt format."),Fn.forEach(t),Vr=u(ke),Xe=a(ke,"P",{});var mt=s(Xe);Rr=l(mt,"The pipeline is set in evaluation mode by default using "),So=a(mt,"CODE",{});var jn=s(So);Hr=l(jn,"model.eval()"),jn.forEach(t),Br=l(mt," (Dropout modules are deactivated)."),mt.forEach(t),Gr=u(ke),y(xe.$$.fragment,ke),ke.forEach(t),ao.forEach(t),this.h()},h(){c(r,"name","hf:doc:metadata"),c(r,"content",JSON.stringify(ta)),c(f,"id","loaders"),c(f,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(f,"href","#loaders"),c(d,"class","relative group"),c(Qe,"href","./training/text_inversion.mdx"),c(Le,"href","https://github.com/cloneofsimo/lora"),c(Le,"rel","nofollow"),c(Me,"href","https://arxiv.org/abs/1609.09106"),c(Me,"rel","nofollow"),c(oe,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/loaders.py"),c(oe,"rel","nofollow"),c(te,"id","loadermixins"),c(te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(te,"href","#loadermixins"),c(H,"class","relative group"),c(re,"id","diffusers.loaders.UNet2DConditionLoadersMixin"),c(re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(re,"href","#diffusers.loaders.UNet2DConditionLoadersMixin"),c(B,"class","relative group"),c(Ie,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py"),c(Ie,"rel","nofollow"),c(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ye,"href","/docs/diffusers/pr_3274/en/api/loaders#diffusers.loaders.UNet2DConditionLoadersMixin.load_attn_procs"),c(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ie,"id","diffusers.loaders.TextualInversionLoaderMixin"),c(ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ie,"href","#diffusers.loaders.TextualInversionLoaderMixin"),c(G,"class","relative group"),c(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(he,"id","diffusers.loaders.LoraLoaderMixin"),c(he,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(he,"href","#diffusers.loaders.LoraLoaderMixin"),c(J,"class","relative group"),c(Ze,"href","/docs/diffusers/pr_3274/en/api/models#diffusers.UNet2DConditionModel"),c(We,"href","https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel"),c(We,"rel","nofollow"),c(eo,"href","/docs/diffusers/pr_3274/en/api/models#diffusers.UNet2DConditionModel"),c(Ve,"href","https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel"),c(Ve,"rel","nofollow"),c(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ve,"id","diffusers.loaders.FromCkptMixin"),c(ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ve,"href","#diffusers.loaders.FromCkptMixin"),c(Y,"class","relative group"),c(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,g){e(document.head,r),x(o,v,g),x(o,d,g),e(d,f),e(f,$),k(p,$,null),e(d,b),e(d,T),e(T,m),x(o,_,g),x(o,C,g),e(C,N),x(o,Bo,g),x(o,V,g),e(V,io),e(io,Qe),e(Qe,gt),e(V,_t),e(V,lo),e(lo,Le),e(Le,vt),e(V,xt),e(V,co),e(co,Me),e(Me,bt),x(o,Go,g),x(o,ee,g),e(ee,$t),e(ee,oe),e(oe,po),e(po,wt),e(oe,yt),e(ee,kt),x(o,Xo,g),x(o,Ee,g),e(Ee,fo),e(fo,Lt),e(Ee,Mt),x(o,Jo,g),x(o,H,g),e(H,te),e(te,ho),k(Te,ho,null),e(H,Et),e(H,uo),e(uo,Tt),x(o,Ko,g),x(o,B,g),e(B,re),e(re,mo),k(De,mo,null),e(B,Dt),e(B,go),e(go,Ct),x(o,Qo,g),x(o,j,g),k(Ce,j,null),e(j,Pt),e(j,U),k(Pe,U,null),e(U,It),e(U,O),e(O,At),e(O,_o),e(_o,qt),e(O,Nt),e(O,Ie),e(Ie,vo),e(vo,Ut),e(O,St),e(O,xo),e(xo,Ft),e(O,jt),e(U,Ot),k(ne,U,null),e(U,Wt),k(ae,U,null),e(j,zt),e(j,se),k(Ae,se,null),e(se,Vt),e(se,qe),e(qe,Rt),e(qe,Ye),e(Ye,Ht),e(qe,Bt),x(o,Yo,g),x(o,G,g),e(G,ie),e(ie,bo),k(Ne,bo,null),e(G,Gt),e(G,$o),e($o,Xt),x(o,Zo,g),x(o,q,g),k(Ue,q,null),e(q,Jt),e(q,wo),e(wo,Kt),e(q,Qt),e(q,P),k(Se,P,null),e(P,Yt),e(P,X),e(X,Zt),e(X,yo),e(yo,er),e(X,or),e(X,ko),e(ko,tr),e(X,rr),e(P,nr),k(le,P,null),e(P,ar),k(de,P,null),e(P,sr),e(P,Lo),e(Lo,ir),e(P,lr),k(ce,P,null),e(P,dr),e(P,Mo),e(Mo,cr),e(P,pr),k(pe,P,null),e(q,fr),e(q,fe),k(Fe,fe,null),e(fe,hr),e(fe,Eo),e(Eo,ur),x(o,et,g),x(o,J,g),e(J,he),e(he,To),k(je,To,null),e(J,mr),e(J,Do),e(Do,gr),x(o,ot,g),x(o,A,g),k(Oe,A,null),e(A,_r),e(A,K),e(K,vr),e(K,Ze),e(Ze,xr),e(K,br),e(K,We),e(We,Co),e(Co,$r),e(K,wr),e(A,yr),k(ue,A,null),e(A,kr),e(A,S),k(ze,S,null),e(S,Lr),e(S,Q),e(Q,Mr),e(Q,eo),e(eo,Er),e(Q,Tr),e(Q,Ve),e(Ve,Po),e(Po,Dr),e(Q,Cr),e(S,Pr),k(me,S,null),e(S,Ir),k(ge,S,null),e(A,Ar),e(A,_e),k(Re,_e,null),e(_e,qr),e(_e,Io),e(Io,Nr),x(o,tt,g),x(o,Y,g),e(Y,ve),e(ve,Ao),k(He,Ao,null),e(Y,Ur),e(Y,qo),e(qo,Sr),x(o,rt,g),x(o,W,g),k(Be,W,null),e(W,Fr),e(W,No),e(No,jr),e(W,Or),e(W,F),k(Ge,F,null),e(F,Wr),e(F,Uo),e(Uo,zr),e(F,Vr),e(F,Xe),e(Xe,Rr),e(Xe,So),e(So,Hr),e(Xe,Br),e(F,Gr),k(xe,F,null),nt=!0},p(o,[g]){const Je={};g&2&&(Je.$$scope={dirty:g,ctx:o}),ne.$set(Je);const Fo={};g&2&&(Fo.$$scope={dirty:g,ctx:o}),ae.$set(Fo);const jo={};g&2&&(jo.$$scope={dirty:g,ctx:o}),le.$set(jo);const Oo={};g&2&&(Oo.$$scope={dirty:g,ctx:o}),de.$set(Oo);const Wo={};g&2&&(Wo.$$scope={dirty:g,ctx:o}),ce.$set(Wo);const Z={};g&2&&(Z.$$scope={dirty:g,ctx:o}),pe.$set(Z);const zo={};g&2&&(zo.$$scope={dirty:g,ctx:o}),ue.$set(zo);const Vo={};g&2&&(Vo.$$scope={dirty:g,ctx:o}),me.$set(Vo);const Ro={};g&2&&(Ro.$$scope={dirty:g,ctx:o}),ge.$set(Ro);const Ho={};g&2&&(Ho.$$scope={dirty:g,ctx:o}),xe.$set(Ho)},i(o){nt||(L(p.$$.fragment,o),L(Te.$$.fragment,o),L(De.$$.fragment,o),L(Ce.$$.fragment,o),L(Pe.$$.fragment,o),L(ne.$$.fragment,o),L(ae.$$.fragment,o),L(Ae.$$.fragment,o),L(Ne.$$.fragment,o),L(Ue.$$.fragment,o),L(Se.$$.fragment,o),L(le.$$.fragment,o),L(de.$$.fragment,o),L(ce.$$.fragment,o),L(pe.$$.fragment,o),L(Fe.$$.fragment,o),L(je.$$.fragment,o),L(Oe.$$.fragment,o),L(ue.$$.fragment,o),L(ze.$$.fragment,o),L(me.$$.fragment,o),L(ge.$$.fragment,o),L(Re.$$.fragment,o),L(He.$$.fragment,o),L(Be.$$.fragment,o),L(Ge.$$.fragment,o),L(xe.$$.fragment,o),nt=!0)},o(o){M(p.$$.fragment,o),M(Te.$$.fragment,o),M(De.$$.fragment,o),M(Ce.$$.fragment,o),M(Pe.$$.fragment,o),M(ne.$$.fragment,o),M(ae.$$.fragment,o),M(Ae.$$.fragment,o),M(Ne.$$.fragment,o),M(Ue.$$.fragment,o),M(Se.$$.fragment,o),M(le.$$.fragment,o),M(de.$$.fragment,o),M(ce.$$.fragment,o),M(pe.$$.fragment,o),M(Fe.$$.fragment,o),M(je.$$.fragment,o),M(Oe.$$.fragment,o),M(ue.$$.fragment,o),M(ze.$$.fragment,o),M(me.$$.fragment,o),M(ge.$$.fragment,o),M(Re.$$.fragment,o),M(He.$$.fragment,o),M(Be.$$.fragment,o),M(Ge.$$.fragment,o),M(xe.$$.fragment,o),nt=!1},d(o){t(r),o&&t(v),o&&t(d),E(p),o&&t(_),o&&t(C),o&&t(Bo),o&&t(V),o&&t(Go),o&&t(ee),o&&t(Xo),o&&t(Ee),o&&t(Jo),o&&t(H),E(Te),o&&t(Ko),o&&t(B),E(De),o&&t(Qo),o&&t(j),E(Ce),E(Pe),E(ne),E(ae),E(Ae),o&&t(Yo),o&&t(G),E(Ne),o&&t(Zo),o&&t(q),E(Ue),E(Se),E(le),E(de),E(ce),E(pe),E(Fe),o&&t(et),o&&t(J),E(je),o&&t(ot),o&&t(A),E(Oe),E(ue),E(ze),E(me),E(ge),E(Re),o&&t(tt),o&&t(Y),E(He),o&&t(rt),o&&t(W),E(Be),E(Ge),E(xe)}}}const ta={local:"loaders",sections:[{local:"loadermixins",sections:[{local:"diffusers.loaders.UNet2DConditionLoadersMixin",title:"UNet2DConditionLoadersMixin"},{local:"diffusers.loaders.TextualInversionLoaderMixin",title:"TextualInversionLoaderMixin"},{local:"diffusers.loaders.LoraLoaderMixin",title:"LoraLoaderMixin"},{local:"diffusers.loaders.FromCkptMixin",title:"FromCkptMixin"}],title:"LoaderMixins"}],title:"Loaders"};function ra(D){return Rn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ca extends On{constructor(r){super();Wn(this,r,ra,oa,zn,{})}}export{ca as default,ta as metadata};
