import{S as Bm,i as Lm,s as Xm,e as a,k as f,w as u,t as i,M as Ym,c as o,d as s,m,a as n,x as _,h as r,b as h,G as t,g as p,y as v,q as b,o as y,B as g,v as Wm}from"../../chunks/vendor-hf-doc-builder.js";import{T as Nn}from"../../chunks/Tip-hf-doc-builder.js";import{I as x}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as D}from"../../chunks/CodeBlock-hf-doc-builder.js";function Km(N){let c;return{c(){c=i("It is strongly discouraged to make use of [`torch.autocast`](https://pytorch.org/docs/stable/amp.html#torch.autocast) in any of the pipelines as it can lead to black images and is always slower than using pure \n  float16 precision.")},l(d){c=r(d,"It is strongly discouraged to make use of [`torch.autocast`](https://pytorch.org/docs/stable/amp.html#torch.autocast) in any of the pipelines as it can lead to black images and is always slower than using pure \n  float16 precision.")},m(d,w){p(d,c,w)},d(d){d&&s(c)}}}function Qm(N){let c;return{c(){c=i(`Attention slicing is useful even if a batch size of just 1 is used - as long
  as the model uses more than one attention head. If there is more than one
  attention head the *QK^T* attention matrix can be computed sequentially for
  each head which can save a significant amount of memory.`)},l(d){c=r(d,`Attention slicing is useful even if a batch size of just 1 is used - as long
  as the model uses more than one attention head. If there is more than one
  attention head the *QK^T* attention matrix can be computed sequentially for
  each head which can save a significant amount of memory.`)},m(d,w){p(d,c,w)},d(d){d&&s(c)}}}function Jm(N){let c,d,w,T;return{c(){c=i("Consider using "),d=a("a"),w=i("model offloading"),T=i(" as another point in the optimization space: it will be much faster, but memory savings won't be as large."),this.h()},l($){c=r($,"Consider using "),d=o($,"A",{href:!0});var j=n(d);w=r(j,"model offloading"),j.forEach(s),T=r($," as another point in the optimization space: it will be much faster, but memory savings won't be as large."),this.h()},h(){h(d,"href","#model_offloading")},m($,j){p($,c,j),p($,d,j),t(d,w),p($,T,j)},d($){$&&s(c),$&&s(d),$&&s(T)}}}function Zm(N){let c;return{c(){c=i("This feature requires `accelerate` version 0.17.0 or larger.")},l(d){c=r(d,"This feature requires `accelerate` version 0.17.0 or larger.")},m(d,w){p(d,c,w)},d(d){d&&s(c)}}}function eh(N){let c,d,w,T,$,j,Un,us,Cn,Xa,q,In,_s,Fn,Rn,Ve,Vn,Gn,vt,Mn,zn,Ya,bt,Hn,Wa,de,vs,M,Ka,On,bs,Bn,Ln,ys,Xn,Yn,P,z,gs,Wn,Kn,ws,Qn,Jn,$s,Zn,ei,H,Es,ti,si,js,ai,oi,ks,ni,ii,O,Ts,ri,li,Ps,pi,fi,As,mi,hi,B,Ds,di,ci,qs,ui,_i,Ss,vi,bi,L,xs,yi,gi,Ns,wi,$i,Us,Ei,Qa,yt,ji,Ja,X,ce,Cs,Ge,ki,Is,Ti,Za,ue,Pi,Me,Ai,Di,eo,ze,to,Y,_e,Fs,He,qi,Rs,Si,so,U,xi,Vs,Ni,Ui,Gs,Ci,Ii,ao,Oe,oo,ve,no,W,be,Ms,Be,Fi,zs,Ri,io,gt,Vi,ro,ye,lo,ge,Gi,wt,Mi,zi,po,Le,fo,$t,Hi,mo,K,we,Hs,Xe,Oi,Os,Bi,ho,Et,Li,co,C,Xi,jt,Yi,Wi,kt,Ki,Qi,uo,$e,Ji,Tt,Zi,er,_o,Ye,vo,Pt,tr,bo,Q,Ee,Bs,We,sr,Ls,ar,yo,At,or,go,I,nr,Dt,ir,rr,qt,lr,pr,wo,je,fr,St,mr,hr,$o,Ke,Eo,xt,dr,jo,Nt,ko,J,ke,Xs,Qe,cr,Ys,ur,To,Ut,_r,Po,Te,vr,Ct,br,yr,Ao,Je,Do,It,gr,qo,Pe,wr,Ws,$r,Er,So,Ae,xo,Ft,jr,No,Ze,Uo,A,Ks,kr,Tr,Qs,Pr,Ar,Js,Dr,qr,et,Sr,xr,Co,Z,Zs,Nr,Ur,ea,Cr,Ir,Io,Rt,Fo,ee,De,ta,tt,Fr,sa,Rr,Ro,st,Vt,Vr,Gr,Vo,F,Mr,aa,zr,Hr,oa,Or,Br,Go,Gt,Lr,Mo,qe,Xr,na,Yr,Wr,zo,at,Ho,Mt,Kr,Oo,ot,Bo,Se,Lo,S,ia,Qr,Jr,ra,Zr,el,nt,tl,sl,Xo,te,xe,la,it,al,pa,ol,Yo,zt,nl,Wo,Ht,il,Ko,rt,Qo,se,Ne,fa,lt,rl,ma,ll,Jo,Ue,pl,ha,fl,ml,Zo,Ot,hl,en,pt,tn,Ce,dl,da,cl,ul,sn,ft,an,ae,Ie,ca,mt,_l,ua,vl,on,R,bl,ht,yl,gl,dt,wl,$l,nn,Bt,El,rn,Fe,_a,oe,va,jl,kl,ba,Tl,Pl,ya,Al,Dl,E,ne,ga,ql,Sl,wa,xl,Nl,$a,Ul,Cl,ie,Ea,Il,Fl,ja,Rl,Vl,ka,Gl,Ml,re,Ta,zl,Hl,Pa,Ol,Bl,Aa,Ll,Xl,le,Da,Yl,Wl,qa,Kl,Ql,Sa,Jl,Zl,pe,xa,ep,tp,Na,sp,ap,Ua,op,np,fe,Ca,ip,rp,Ia,lp,pp,Fa,fp,mp,me,Ra,hp,dp,Va,cp,up,Ga,_p,ln,Lt,vp,pn,V,Ma,bp,yp,za,gp,wp,Xt,Yt,$p,Ep,fn,ct,mn;return j=new x({}),Ge=new x({}),ze=new D({props:{code:`import torch

torch.backends.cuda.matmul.allow_tf32 = True`,highlighted:`<span class="hljs-keyword">import</span> torch

torch.backends.cuda.matmul.allow_tf32 = <span class="hljs-literal">True</span>`}}),He=new x({}),Oe=new D({props:{code:`import torch
from diffusers import DiffusionPipeline

pipe = DiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline

pipe = DiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),ve=new Nn({props:{warning:!0,$$slots:{default:[Km]},$$scope:{ctx:N}}}),Be=new x({}),ye=new Nn({props:{$$slots:{default:[Qm]},$$scope:{ctx:N}}}),Le=new D({props:{code:`import torch
from diffusers import DiffusionPipeline

pipe = DiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_attention_slicing()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline

pipe = DiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_attention_slicing()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Xe=new x({}),Ye=new D({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_vae_slicing()
images = pipe([prompt] * 32).images`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_vae_slicing()
images = pipe([prompt] * <span class="hljs-number">32</span>).images`}}),We=new x({}),Ke=new D({props:{code:`import torch
from diffusers import StableDiffusionPipeline, UniPCMultistepScheduler

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
pipe = pipe.to("cuda")
prompt = "a beautiful landscape photograph"
pipe.enable_vae_tiling()
pipe.enable_xformers_memory_efficient_attention()

image = pipe([prompt], width=3840, height=2224, num_inference_steps=20).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline, UniPCMultistepScheduler

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
)
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
prompt = <span class="hljs-string">&quot;a beautiful landscape photograph&quot;</span>
pipe.enable_vae_tiling()
pipe.enable_xformers_memory_efficient_attention()

image = pipe([prompt], width=<span class="hljs-number">3840</span>, height=<span class="hljs-number">2224</span>, num_inference_steps=<span class="hljs-number">20</span>).images[<span class="hljs-number">0</span>]`}}),Qe=new x({}),Je=new D({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_sequential_cpu_offload()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_sequential_cpu_offload()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Ae=new Nn({props:{$$slots:{default:[Jm]},$$scope:{ctx:N}}}),Ze=new D({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_sequential_cpu_offload()
pipe.enable_attention_slicing(1)

image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_sequential_cpu_offload()
pipe.enable_attention_slicing(<span class="hljs-number">1</span>)

image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),tt=new x({}),at=new D({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",  
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_model_cpu_offload()
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,  
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_model_cpu_offload()
image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),ot=new D({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
)

prompt = "a photo of an astronaut riding a horse on mars"
pipe.enable_model_cpu_offload()
pipe.enable_attention_slicing(1)

image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
)

prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
pipe.enable_model_cpu_offload()
pipe.enable_attention_slicing(<span class="hljs-number">1</span>)

image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),Se=new Nn({props:{$$slots:{default:[Zm]},$$scope:{ctx:N}}}),it=new x({}),rt=new D({props:{code:`print(pipe.unet.conv_out.state_dict()["weight"].stride())  # (2880, 9, 3, 1)
pipe.unet.to(memory_format=torch.channels_last)  # in-place operation
print(
    pipe.unet.conv_out.state_dict()["weight"].stride()
)  # (2880, 1, 960, 320) having a stride of 1 for the 2nd dimension proves that it works`,highlighted:`<span class="hljs-built_in">print</span>(pipe.unet.conv_out.state_dict()[<span class="hljs-string">&quot;weight&quot;</span>].stride())  <span class="hljs-comment"># (2880, 9, 3, 1)</span>
pipe.unet.to(memory_format=torch.channels_last)  <span class="hljs-comment"># in-place operation</span>
<span class="hljs-built_in">print</span>(
    pipe.unet.conv_out.state_dict()[<span class="hljs-string">&quot;weight&quot;</span>].stride()
)  <span class="hljs-comment"># (2880, 1, 960, 320) having a stride of 1 for the 2nd dimension proves that it works</span>`}}),lt=new x({}),pt=new D({props:{code:`import time
import torch
from diffusers import StableDiffusionPipeline
import functools

# torch disable grad
torch.set_grad_enabled(False)

# set variables
n_experiments = 2
unet_runs_per_experiment = 50


# load inputs
def generate_inputs():
    sample = torch.randn(2, 4, 64, 64).half().cuda()
    timestep = torch.rand(1).half().cuda() * 999
    encoder_hidden_states = torch.randn(2, 77, 768).half().cuda()
    return sample, timestep, encoder_hidden_states


pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")
unet = pipe.unet
unet.eval()
unet.to(memory_format=torch.channels_last)  # use channels_last memory format
unet.forward = functools.partial(unet.forward, return_dict=False)  # set return_dict=False as default

# warmup
for _ in range(3):
    with torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet(*inputs)

# trace
print("tracing..")
unet_traced = torch.jit.trace(unet, inputs)
unet_traced.eval()
print("done tracing")


# warmup and optimize graph
for _ in range(5):
    with torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet_traced(*inputs)


# benchmarking
with torch.inference_mode():
    for _ in range(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        for _ in range(unet_runs_per_experiment):
            orig_output = unet_traced(*inputs)
        torch.cuda.synchronize()
        print(f"unet traced inference took {time.time() - start_time:.2f} seconds")
    for _ in range(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        for _ in range(unet_runs_per_experiment):
            orig_output = unet(*inputs)
        torch.cuda.synchronize()
        print(f"unet inference took {time.time() - start_time:.2f} seconds")

# save the model
unet_traced.save("unet_traced.pt")`,highlighted:`<span class="hljs-keyword">import</span> time
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> functools

<span class="hljs-comment"># torch disable grad</span>
torch.set_grad_enabled(<span class="hljs-literal">False</span>)

<span class="hljs-comment"># set variables</span>
n_experiments = <span class="hljs-number">2</span>
unet_runs_per_experiment = <span class="hljs-number">50</span>


<span class="hljs-comment"># load inputs</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">generate_inputs</span>():
    sample = torch.randn(<span class="hljs-number">2</span>, <span class="hljs-number">4</span>, <span class="hljs-number">64</span>, <span class="hljs-number">64</span>).half().cuda()
    timestep = torch.rand(<span class="hljs-number">1</span>).half().cuda() * <span class="hljs-number">999</span>
    encoder_hidden_states = torch.randn(<span class="hljs-number">2</span>, <span class="hljs-number">77</span>, <span class="hljs-number">768</span>).half().cuda()
    <span class="hljs-keyword">return</span> sample, timestep, encoder_hidden_states


pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)
unet = pipe.unet
unet.<span class="hljs-built_in">eval</span>()
unet.to(memory_format=torch.channels_last)  <span class="hljs-comment"># use channels_last memory format</span>
unet.forward = functools.partial(unet.forward, return_dict=<span class="hljs-literal">False</span>)  <span class="hljs-comment"># set return_dict=False as default</span>

<span class="hljs-comment"># warmup</span>
<span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">3</span>):
    <span class="hljs-keyword">with</span> torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet(*inputs)

<span class="hljs-comment"># trace</span>
<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;tracing..&quot;</span>)
unet_traced = torch.jit.trace(unet, inputs)
unet_traced.<span class="hljs-built_in">eval</span>()
<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;done tracing&quot;</span>)


<span class="hljs-comment"># warmup and optimize graph</span>
<span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">5</span>):
    <span class="hljs-keyword">with</span> torch.inference_mode():
        inputs = generate_inputs()
        orig_output = unet_traced(*inputs)


<span class="hljs-comment"># benchmarking</span>
<span class="hljs-keyword">with</span> torch.inference_mode():
    <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(unet_runs_per_experiment):
            orig_output = unet_traced(*inputs)
        torch.cuda.synchronize()
        <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;unet traced inference took <span class="hljs-subst">{time.time() - start_time:<span class="hljs-number">.2</span>f}</span> seconds&quot;</span>)
    <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(n_experiments):
        torch.cuda.synchronize()
        start_time = time.time()
        <span class="hljs-keyword">for</span> _ <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(unet_runs_per_experiment):
            orig_output = unet(*inputs)
        torch.cuda.synchronize()
        <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;unet inference took <span class="hljs-subst">{time.time() - start_time:<span class="hljs-number">.2</span>f}</span> seconds&quot;</span>)

<span class="hljs-comment"># save the model</span>
unet_traced.save(<span class="hljs-string">&quot;unet_traced.pt&quot;</span>)`}}),ft=new D({props:{code:`from diffusers import StableDiffusionPipeline
import torch
from dataclasses import dataclass


@dataclass
class UNet2DConditionOutput:
    sample: torch.FloatTensor


pipe = StableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")

# use jitted unet
unet_traced = torch.jit.load("unet_traced.pt")


# del pipe.unet
class TracedUNet(torch.nn.Module):
    def __init__(self):
        super().__init__()
        self.in_channels = pipe.unet.in_channels
        self.device = pipe.unet.device

    def forward(self, latent_model_input, t, encoder_hidden_states):
        sample = unet_traced(latent_model_input, t, encoder_hidden_states)[0]
        return UNet2DConditionOutput(sample=sample)


pipe.unet = TracedUNet()

with torch.inference_mode():
    image = pipe([prompt] * 1, num_inference_steps=50).images[0]`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> dataclasses <span class="hljs-keyword">import</span> dataclass


<span class="hljs-meta">@dataclass</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">UNet2DConditionOutput</span>:
    sample: torch.FloatTensor


pipe = StableDiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-comment"># use jitted unet</span>
unet_traced = torch.jit.load(<span class="hljs-string">&quot;unet_traced.pt&quot;</span>)


<span class="hljs-comment"># del pipe.unet</span>
<span class="hljs-keyword">class</span> <span class="hljs-title class_">TracedUNet</span>(torch.nn.Module):
    <span class="hljs-keyword">def</span> <span class="hljs-title function_">__init__</span>(<span class="hljs-params">self</span>):
        <span class="hljs-built_in">super</span>().__init__()
        self.in_channels = pipe.unet.in_channels
        self.device = pipe.unet.device

    <span class="hljs-keyword">def</span> <span class="hljs-title function_">forward</span>(<span class="hljs-params">self, latent_model_input, t, encoder_hidden_states</span>):
        sample = unet_traced(latent_model_input, t, encoder_hidden_states)[<span class="hljs-number">0</span>]
        <span class="hljs-keyword">return</span> UNet2DConditionOutput(sample=sample)


pipe.unet = TracedUNet()

<span class="hljs-keyword">with</span> torch.inference_mode():
    image = pipe([prompt] * <span class="hljs-number">1</span>, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]`}}),mt=new x({}),ct=new D({props:{code:`from diffusers import DiffusionPipeline
import torch

pipe = DiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5",
    torch_dtype=torch.float16,
).to("cuda")

pipe.enable_xformers_memory_efficient_attention()

with torch.inference_mode():
    sample = pipe("a small cat")

# optional: You can disable it via
# pipe.disable_xformers_memory_efficient_attention()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-keyword">import</span> torch

pipe = DiffusionPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>,
    torch_dtype=torch.float16,
).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-keyword">with</span> torch.inference_mode():
    sample = pipe(<span class="hljs-string">&quot;a small cat&quot;</span>)

<span class="hljs-comment"># optional: You can disable it via</span>
<span class="hljs-comment"># pipe.disable_xformers_memory_efficient_attention()</span>`}}),{c(){c=a("meta"),d=f(),w=a("h1"),T=a("a"),$=a("span"),u(j.$$.fragment),Un=f(),us=a("span"),Cn=i("Memory and speed"),Xa=f(),q=a("p"),In=i("We present some techniques and ideas to optimize \u{1F917} Diffusers "),_s=a("em"),Fn=i("inference"),Rn=i(" for memory or speed. As a general rule, we recommend the use of "),Ve=a("a"),Vn=i("xFormers"),Gn=i(" for memory efficient attention, please see the recommended "),vt=a("a"),Mn=i("installation instructions"),zn=i("."),Ya=f(),bt=a("p"),Hn=i("We\u2019ll discuss how the following settings impact performance and memory."),Wa=f(),de=a("table"),vs=a("thead"),M=a("tr"),Ka=a("th"),On=f(),bs=a("th"),Bn=i("Latency"),Ln=f(),ys=a("th"),Xn=i("Speedup"),Yn=f(),P=a("tbody"),z=a("tr"),gs=a("td"),Wn=i("original"),Kn=f(),ws=a("td"),Qn=i("9.50s"),Jn=f(),$s=a("td"),Zn=i("x1"),ei=f(),H=a("tr"),Es=a("td"),ti=i("fp16"),si=f(),js=a("td"),ai=i("3.61s"),oi=f(),ks=a("td"),ni=i("x2.63"),ii=f(),O=a("tr"),Ts=a("td"),ri=i("channels last"),li=f(),Ps=a("td"),pi=i("3.30s"),fi=f(),As=a("td"),mi=i("x2.88"),hi=f(),B=a("tr"),Ds=a("td"),di=i("traced UNet"),ci=f(),qs=a("td"),ui=i("3.21s"),_i=f(),Ss=a("td"),vi=i("x2.96"),bi=f(),L=a("tr"),xs=a("td"),yi=i("memory efficient attention"),gi=f(),Ns=a("td"),wi=i("2.63s"),$i=f(),Us=a("td"),Ei=i("x3.61"),Qa=f(),yt=a("em"),ji=i(`obtained on NVIDIA TITAN RTX by generating a single image of size 512x512 from
  the prompt "a photo of an astronaut riding a horse on mars" with 50 DDIM
  steps.`),Ja=f(),X=a("h3"),ce=a("a"),Cs=a("span"),u(Ge.$$.fragment),ki=f(),Is=a("span"),Ti=i("Use tf32 instead of fp32 (on Ampere and later CUDA devices)"),Za=f(),ue=a("p"),Pi=i("On Ampere and later CUDA devices matrix multiplications and convolutions can use the TensorFloat32 (TF32) mode for faster but slightly less accurate computations. By default PyTorch enables TF32 mode for convolutions but not matrix multiplications, and unless a network requires full float32 precision we recommend enabling this setting for matrix multiplications, too. It can significantly speed up computations with typically negligible loss of numerical accuracy. You can read more about it "),Me=a("a"),Ai=i("here"),Di=i(". All you need to do is to add this before your inference:"),eo=f(),u(ze.$$.fragment),to=f(),Y=a("h2"),_e=a("a"),Fs=a("span"),u(He.$$.fragment),qi=f(),Rs=a("span"),Si=i("Half precision weights"),so=f(),U=a("p"),xi=i("To save more GPU memory and get more speed, you can load and run the model weights directly in half precision. This involves loading the float16 version of the weights, which was saved to a branch named "),Vs=a("code"),Ni=i("fp16"),Ui=i(", and telling PyTorch to use the "),Gs=a("code"),Ci=i("float16"),Ii=i(" type when loading them:"),ao=f(),u(Oe.$$.fragment),oo=f(),u(ve.$$.fragment),no=f(),W=a("h2"),be=a("a"),Ms=a("span"),u(Be.$$.fragment),Fi=f(),zs=a("span"),Ri=i("Sliced attention for additional memory savings"),io=f(),gt=a("p"),Vi=i("For even additional memory savings, you can use a sliced version of attention that performs the computation in steps instead of all at once."),ro=f(),u(ye.$$.fragment),lo=f(),ge=a("p"),Gi=i("To perform the attention computation sequentially over each head, you only need to invoke "),wt=a("a"),Mi=i("enable_attention_slicing()"),zi=i(" in your pipeline before inference, like here:"),po=f(),u(Le.$$.fragment),fo=f(),$t=a("p"),Hi=i("There\u2019s a small performance penalty of about 10% slower inference times, but this method allows you to use Stable Diffusion in as little as 3.2 GB of VRAM!"),mo=f(),K=a("h2"),we=a("a"),Hs=a("span"),u(Xe.$$.fragment),Oi=f(),Os=a("span"),Bi=i("Sliced VAE decode for larger batches"),ho=f(),Et=a("p"),Li=i("To decode large batches of images with limited VRAM, or to enable batches with 32 images or more, you can use sliced VAE decode that decodes the batch latents one image at a time."),co=f(),C=a("p"),Xi=i("You likely want to couple this with "),jt=a("a"),Yi=i("enable_attention_slicing()"),Wi=i(" or "),kt=a("a"),Ki=i("enable_xformers_memory_efficient_attention()"),Qi=i(" to further minimize memory use."),uo=f(),$e=a("p"),Ji=i("To perform the VAE decode one image at a time, invoke "),Tt=a("a"),Zi=i("enable_vae_slicing()"),er=i(" in your pipeline before inference. For example:"),_o=f(),u(Ye.$$.fragment),vo=f(),Pt=a("p"),tr=i("You may see a small performance boost in VAE decode on multi-image batches. There should be no performance impact on single-image batches."),bo=f(),Q=a("h2"),Ee=a("a"),Bs=a("span"),u(We.$$.fragment),sr=f(),Ls=a("span"),ar=i("Tiled VAE decode and encode for large images"),yo=f(),At=a("p"),or=i("Tiled VAE processing makes it possible to work with large images on limited VRAM. For example, generating 4k images in 8GB of VRAM. Tiled VAE decoder splits the image into overlapping tiles, decodes the tiles, and blends the outputs to make the final image."),go=f(),I=a("p"),nr=i("You want to couple this with "),Dt=a("a"),ir=i("enable_attention_slicing()"),rr=i(" or "),qt=a("a"),lr=i("enable_xformers_memory_efficient_attention()"),pr=i(" to further minimize memory use."),wo=f(),je=a("p"),fr=i("To use tiled VAE processing, invoke "),St=a("a"),mr=i("enable_vae_tiling()"),hr=i(" in your pipeline before inference. For example:"),$o=f(),u(Ke.$$.fragment),Eo=f(),xt=a("p"),dr=i("The output image will have some tile-to-tile tone variation from the tiles having separate decoders, but you shouldn\u2019t see sharp seams between the tiles. The tiling is turned off for images that are 512x512 or smaller."),jo=f(),Nt=a("a"),ko=f(),J=a("h2"),ke=a("a"),Xs=a("span"),u(Qe.$$.fragment),cr=f(),Ys=a("span"),ur=i("Offloading to CPU with accelerate for memory savings"),To=f(),Ut=a("p"),_r=i("For additional memory savings, you can offload the weights to CPU and only load them to GPU when performing the forward pass."),Po=f(),Te=a("p"),vr=i("To perform CPU offloading, all you have to do is invoke "),Ct=a("a"),br=i("enable_sequential_cpu_offload()"),yr=i(":"),Ao=f(),u(Je.$$.fragment),Do=f(),It=a("p"),gr=i("And you can get the memory consumption to < 3GB."),qo=f(),Pe=a("p"),wr=i("Note that this method works at the submodule level, not on whole models. This is the best way to minimize memory consumption, but inference is much slower due to the iterative nature of the process. The UNet component of the pipeline runs several times (as many as "),Ws=a("code"),$r=i("num_inference_steps"),Er=i("); each time, the different submodules of the UNet are sequentially onloaded and then offloaded as they are needed, so the number of memory transfers is large."),So=f(),u(Ae.$$.fragment),xo=f(),Ft=a("p"),jr=i("It is also possible to chain offloading with attention slicing for minimal memory consumption (< 2GB)."),No=f(),u(Ze.$$.fragment),Uo=f(),A=a("p"),Ks=a("strong"),kr=i("Note"),Tr=i(": When using "),Qs=a("code"),Pr=i("enable_sequential_cpu_offload()"),Ar=i(", it is important to "),Js=a("strong"),Dr=i("not"),qr=i(" move the pipeline to CUDA beforehand or else the gain in memory consumption will only be minimal. See "),et=a("a"),Sr=i("this issue"),xr=i(" for more information."),Co=f(),Z=a("p"),Zs=a("strong"),Nr=i("Note"),Ur=i(": "),ea=a("code"),Cr=i("enable_sequential_cpu_offload()"),Ir=i(" is a stateful operation that installs hooks on the models."),Io=f(),Rt=a("a"),Fo=f(),ee=a("h2"),De=a("a"),ta=a("span"),u(tt.$$.fragment),Fr=f(),sa=a("span"),Rr=i("Model offloading for fast inference and memory savings"),Ro=f(),st=a("p"),Vt=a("a"),Vr=i("Sequential CPU offloading"),Gr=i(", as discussed in the previous section, preserves a lot of memory but makes inference slower, because submodules are moved to GPU as needed, and immediately returned to CPU when a new module runs."),Vo=f(),F=a("p"),Mr=i("Full-model offloading is an alternative that moves whole models to the GPU, instead of handling each model\u2019s constituent "),aa=a("em"),zr=i("modules"),Hr=i(". This results in a negligible impact on inference time (compared with moving the pipeline to "),oa=a("code"),Or=i("cuda"),Br=i("), while still providing some memory savings."),Go=f(),Gt=a("p"),Lr=i(`In this scenario, only one of the main components of the pipeline (typically: text encoder, unet and vae)
will be in the GPU while the others wait in the CPU. Components like the UNet that run for multiple iterations will stay on GPU until they are no longer needed.`),Mo=f(),qe=a("p"),Xr=i("This feature can be enabled by invoking "),na=a("code"),Yr=i("enable_model_cpu_offload()"),Wr=i(" on the pipeline, as shown below."),zo=f(),u(at.$$.fragment),Ho=f(),Mt=a("p"),Kr=i("This is also compatible with attention slicing for additional memory savings."),Oo=f(),u(ot.$$.fragment),Bo=f(),u(Se.$$.fragment),Lo=f(),S=a("p"),ia=a("strong"),Qr=i("Note"),Jr=i(": "),ra=a("code"),Zr=i("enable_model_cpu_offload()"),el=i(` is a stateful operation that installs hooks on the models and state on the pipeline. In order to properly offload
models after they are called, it is required that the entire pipeline is run and models are called in the order the pipeline expects them to be. Exercise caution
if models are re-used outside the context of the pipeline after hooks have been installed. See `),nt=a("a"),tl=i("accelerate"),sl=i(`
for further docs on removing hooks.`),Xo=f(),te=a("h2"),xe=a("a"),la=a("span"),u(it.$$.fragment),al=f(),pa=a("span"),ol=i("Using Channels Last memory format"),Yo=f(),zt=a("p"),nl=i("Channels last memory format is an alternative way of ordering NCHW tensors in memory preserving dimensions ordering. Channels last tensors ordered in such a way that channels become the densest dimension (aka storing images pixel-per-pixel). Since not all operators currently support channels last format it may result in a worst performance, so it\u2019s better to try it and see if it works for your model."),Wo=f(),Ht=a("p"),il=i("For example, in order to set the UNet model in our pipeline to use channels last format, we can use the following:"),Ko=f(),u(rt.$$.fragment),Qo=f(),se=a("h2"),Ne=a("a"),fa=a("span"),u(lt.$$.fragment),rl=f(),ma=a("span"),ll=i("Tracing"),Jo=f(),Ue=a("p"),pl=i("Tracing runs an example input tensor through your model, and captures the operations that are invoked as that input makes its way through the model\u2019s layers so that an executable or "),ha=a("code"),fl=i("ScriptFunction"),ml=i(" is returned that will be optimized using just-in-time compilation."),Zo=f(),Ot=a("p"),hl=i("To trace our UNet model, we can use the following:"),en=f(),u(pt.$$.fragment),tn=f(),Ce=a("p"),dl=i("Then we can replace the "),da=a("code"),cl=i("unet"),ul=i(" attribute of the pipeline with the traced model like the following"),sn=f(),u(ft.$$.fragment),an=f(),ae=a("h2"),Ie=a("a"),ca=a("span"),u(mt.$$.fragment),_l=f(),ua=a("span"),vl=i("Memory Efficient Attention"),on=f(),R=a("p"),bl=i("Recent work on optimizing the bandwitdh in the attention block has generated huge speed ups and gains in GPU memory usage. The most recent being Flash Attention from @tridao: "),ht=a("a"),yl=i("code"),gl=i(", "),dt=a("a"),wl=i("paper"),$l=i("."),nn=f(),Bt=a("p"),El=i("Here are the speedups we obtain on a few Nvidia GPUs when running the inference at 512x512 with a batch size of 1 (one prompt):"),rn=f(),Fe=a("table"),_a=a("thead"),oe=a("tr"),va=a("th"),jl=i("GPU"),kl=f(),ba=a("th"),Tl=i("Base Attention FP16"),Pl=f(),ya=a("th"),Al=i("Memory Efficient Attention FP16"),Dl=f(),E=a("tbody"),ne=a("tr"),ga=a("td"),ql=i("NVIDIA Tesla T4"),Sl=f(),wa=a("td"),xl=i("3.5it/s"),Nl=f(),$a=a("td"),Ul=i("5.5it/s"),Cl=f(),ie=a("tr"),Ea=a("td"),Il=i("NVIDIA 3060 RTX"),Fl=f(),ja=a("td"),Rl=i("4.6it/s"),Vl=f(),ka=a("td"),Gl=i("7.8it/s"),Ml=f(),re=a("tr"),Ta=a("td"),zl=i("NVIDIA A10G"),Hl=f(),Pa=a("td"),Ol=i("8.88it/s"),Bl=f(),Aa=a("td"),Ll=i("15.6it/s"),Xl=f(),le=a("tr"),Da=a("td"),Yl=i("NVIDIA RTX A6000"),Wl=f(),qa=a("td"),Kl=i("11.7it/s"),Ql=f(),Sa=a("td"),Jl=i("21.09it/s"),Zl=f(),pe=a("tr"),xa=a("td"),ep=i("NVIDIA TITAN RTX"),tp=f(),Na=a("td"),sp=i("12.51it/s"),ap=f(),Ua=a("td"),op=i("18.22it/s"),np=f(),fe=a("tr"),Ca=a("td"),ip=i("A100-SXM4-40GB"),rp=f(),Ia=a("td"),lp=i("18.6it/s"),pp=f(),Fa=a("td"),fp=i("29.it/s"),mp=f(),me=a("tr"),Ra=a("td"),hp=i("A100-SXM-80GB"),dp=f(),Va=a("td"),cp=i("18.7it/s"),up=f(),Ga=a("td"),_p=i("29.5it/s"),ln=f(),Lt=a("p"),vp=i("To leverage it just make sure you have:"),pn=f(),V=a("ul"),Ma=a("li"),bp=i("PyTorch > 1.12"),yp=f(),za=a("li"),gp=i("Cuda available"),wp=f(),Xt=a("li"),Yt=a("a"),$p=i("Installed the xformers library"),Ep=i("."),fn=f(),u(ct.$$.fragment),this.h()},l(e){const l=Ym('[data-svelte="svelte-1phssyn"]',document.head);c=o(l,"META",{name:!0,content:!0}),l.forEach(s),d=m(e),w=o(e,"H1",{class:!0});var ut=n(w);T=o(ut,"A",{id:!0,class:!0,href:!0});var Ha=n(T);$=o(Ha,"SPAN",{});var Oa=n($);_(j.$$.fragment,Oa),Oa.forEach(s),Ha.forEach(s),Un=m(ut),us=o(ut,"SPAN",{});var Ba=n(us);Cn=r(Ba,"Memory and speed"),Ba.forEach(s),ut.forEach(s),Xa=m(e),q=o(e,"P",{});var Re=n(q);In=r(Re,"We present some techniques and ideas to optimize \u{1F917} Diffusers "),_s=o(Re,"EM",{});var Tp=n(_s);Fn=r(Tp,"inference"),Tp.forEach(s),Rn=r(Re," for memory or speed. As a general rule, we recommend the use of "),Ve=o(Re,"A",{href:!0,rel:!0});var Pp=n(Ve);Vn=r(Pp,"xFormers"),Pp.forEach(s),Gn=r(Re," for memory efficient attention, please see the recommended "),vt=o(Re,"A",{href:!0});var Ap=n(vt);Mn=r(Ap,"installation instructions"),Ap.forEach(s),zn=r(Re,"."),Re.forEach(s),Ya=m(e),bt=o(e,"P",{});var Dp=n(bt);Hn=r(Dp,"We\u2019ll discuss how the following settings impact performance and memory."),Dp.forEach(s),Wa=m(e),de=o(e,"TABLE",{});var hn=n(de);vs=o(hn,"THEAD",{});var qp=n(vs);M=o(qp,"TR",{});var Wt=n(M);Ka=o(Wt,"TH",{}),n(Ka).forEach(s),On=m(Wt),bs=o(Wt,"TH",{});var Sp=n(bs);Bn=r(Sp,"Latency"),Sp.forEach(s),Ln=m(Wt),ys=o(Wt,"TH",{});var xp=n(ys);Xn=r(xp,"Speedup"),xp.forEach(s),Wt.forEach(s),qp.forEach(s),Yn=m(hn),P=o(hn,"TBODY",{});var G=n(P);z=o(G,"TR",{});var Kt=n(z);gs=o(Kt,"TD",{});var Np=n(gs);Wn=r(Np,"original"),Np.forEach(s),Kn=m(Kt),ws=o(Kt,"TD",{});var Up=n(ws);Qn=r(Up,"9.50s"),Up.forEach(s),Jn=m(Kt),$s=o(Kt,"TD",{});var Cp=n($s);Zn=r(Cp,"x1"),Cp.forEach(s),Kt.forEach(s),ei=m(G),H=o(G,"TR",{});var Qt=n(H);Es=o(Qt,"TD",{});var Ip=n(Es);ti=r(Ip,"fp16"),Ip.forEach(s),si=m(Qt),js=o(Qt,"TD",{});var Fp=n(js);ai=r(Fp,"3.61s"),Fp.forEach(s),oi=m(Qt),ks=o(Qt,"TD",{});var Rp=n(ks);ni=r(Rp,"x2.63"),Rp.forEach(s),Qt.forEach(s),ii=m(G),O=o(G,"TR",{});var Jt=n(O);Ts=o(Jt,"TD",{});var Vp=n(Ts);ri=r(Vp,"channels last"),Vp.forEach(s),li=m(Jt),Ps=o(Jt,"TD",{});var Gp=n(Ps);pi=r(Gp,"3.30s"),Gp.forEach(s),fi=m(Jt),As=o(Jt,"TD",{});var Mp=n(As);mi=r(Mp,"x2.88"),Mp.forEach(s),Jt.forEach(s),hi=m(G),B=o(G,"TR",{});var Zt=n(B);Ds=o(Zt,"TD",{});var zp=n(Ds);di=r(zp,"traced UNet"),zp.forEach(s),ci=m(Zt),qs=o(Zt,"TD",{});var Hp=n(qs);ui=r(Hp,"3.21s"),Hp.forEach(s),_i=m(Zt),Ss=o(Zt,"TD",{});var Op=n(Ss);vi=r(Op,"x2.96"),Op.forEach(s),Zt.forEach(s),bi=m(G),L=o(G,"TR",{});var es=n(L);xs=o(es,"TD",{});var Bp=n(xs);yi=r(Bp,"memory efficient attention"),Bp.forEach(s),gi=m(es),Ns=o(es,"TD",{});var Lp=n(Ns);wi=r(Lp,"2.63s"),Lp.forEach(s),$i=m(es),Us=o(es,"TD",{});var Xp=n(Us);Ei=r(Xp,"x3.61"),Xp.forEach(s),es.forEach(s),G.forEach(s),hn.forEach(s),Qa=m(e),yt=o(e,"EM",{});var Yp=n(yt);ji=r(Yp,`obtained on NVIDIA TITAN RTX by generating a single image of size 512x512 from
  the prompt "a photo of an astronaut riding a horse on mars" with 50 DDIM
  steps.`),Yp.forEach(s),Ja=m(e),X=o(e,"H3",{class:!0});var dn=n(X);ce=o(dn,"A",{id:!0,class:!0,href:!0});var Wp=n(ce);Cs=o(Wp,"SPAN",{});var Kp=n(Cs);_(Ge.$$.fragment,Kp),Kp.forEach(s),Wp.forEach(s),ki=m(dn),Is=o(dn,"SPAN",{});var Qp=n(Is);Ti=r(Qp,"Use tf32 instead of fp32 (on Ampere and later CUDA devices)"),Qp.forEach(s),dn.forEach(s),Za=m(e),ue=o(e,"P",{});var cn=n(ue);Pi=r(cn,"On Ampere and later CUDA devices matrix multiplications and convolutions can use the TensorFloat32 (TF32) mode for faster but slightly less accurate computations. By default PyTorch enables TF32 mode for convolutions but not matrix multiplications, and unless a network requires full float32 precision we recommend enabling this setting for matrix multiplications, too. It can significantly speed up computations with typically negligible loss of numerical accuracy. You can read more about it "),Me=o(cn,"A",{href:!0,rel:!0});var Jp=n(Me);Ai=r(Jp,"here"),Jp.forEach(s),Di=r(cn,". All you need to do is to add this before your inference:"),cn.forEach(s),eo=m(e),_(ze.$$.fragment,e),to=m(e),Y=o(e,"H2",{class:!0});var un=n(Y);_e=o(un,"A",{id:!0,class:!0,href:!0});var Zp=n(_e);Fs=o(Zp,"SPAN",{});var ef=n(Fs);_(He.$$.fragment,ef),ef.forEach(s),Zp.forEach(s),qi=m(un),Rs=o(un,"SPAN",{});var tf=n(Rs);Si=r(tf,"Half precision weights"),tf.forEach(s),un.forEach(s),so=m(e),U=o(e,"P",{});var ts=n(U);xi=r(ts,"To save more GPU memory and get more speed, you can load and run the model weights directly in half precision. This involves loading the float16 version of the weights, which was saved to a branch named "),Vs=o(ts,"CODE",{});var sf=n(Vs);Ni=r(sf,"fp16"),sf.forEach(s),Ui=r(ts,", and telling PyTorch to use the "),Gs=o(ts,"CODE",{});var af=n(Gs);Ci=r(af,"float16"),af.forEach(s),Ii=r(ts," type when loading them:"),ts.forEach(s),ao=m(e),_(Oe.$$.fragment,e),oo=m(e),_(ve.$$.fragment,e),no=m(e),W=o(e,"H2",{class:!0});var _n=n(W);be=o(_n,"A",{id:!0,class:!0,href:!0});var of=n(be);Ms=o(of,"SPAN",{});var nf=n(Ms);_(Be.$$.fragment,nf),nf.forEach(s),of.forEach(s),Fi=m(_n),zs=o(_n,"SPAN",{});var rf=n(zs);Ri=r(rf,"Sliced attention for additional memory savings"),rf.forEach(s),_n.forEach(s),io=m(e),gt=o(e,"P",{});var lf=n(gt);Vi=r(lf,"For even additional memory savings, you can use a sliced version of attention that performs the computation in steps instead of all at once."),lf.forEach(s),ro=m(e),_(ye.$$.fragment,e),lo=m(e),ge=o(e,"P",{});var vn=n(ge);Gi=r(vn,"To perform the attention computation sequentially over each head, you only need to invoke "),wt=o(vn,"A",{href:!0});var pf=n(wt);Mi=r(pf,"enable_attention_slicing()"),pf.forEach(s),zi=r(vn," in your pipeline before inference, like here:"),vn.forEach(s),po=m(e),_(Le.$$.fragment,e),fo=m(e),$t=o(e,"P",{});var ff=n($t);Hi=r(ff,"There\u2019s a small performance penalty of about 10% slower inference times, but this method allows you to use Stable Diffusion in as little as 3.2 GB of VRAM!"),ff.forEach(s),mo=m(e),K=o(e,"H2",{class:!0});var bn=n(K);we=o(bn,"A",{id:!0,class:!0,href:!0});var mf=n(we);Hs=o(mf,"SPAN",{});var hf=n(Hs);_(Xe.$$.fragment,hf),hf.forEach(s),mf.forEach(s),Oi=m(bn),Os=o(bn,"SPAN",{});var df=n(Os);Bi=r(df,"Sliced VAE decode for larger batches"),df.forEach(s),bn.forEach(s),ho=m(e),Et=o(e,"P",{});var cf=n(Et);Li=r(cf,"To decode large batches of images with limited VRAM, or to enable batches with 32 images or more, you can use sliced VAE decode that decodes the batch latents one image at a time."),cf.forEach(s),co=m(e),C=o(e,"P",{});var ss=n(C);Xi=r(ss,"You likely want to couple this with "),jt=o(ss,"A",{href:!0});var uf=n(jt);Yi=r(uf,"enable_attention_slicing()"),uf.forEach(s),Wi=r(ss," or "),kt=o(ss,"A",{href:!0});var _f=n(kt);Ki=r(_f,"enable_xformers_memory_efficient_attention()"),_f.forEach(s),Qi=r(ss," to further minimize memory use."),ss.forEach(s),uo=m(e),$e=o(e,"P",{});var yn=n($e);Ji=r(yn,"To perform the VAE decode one image at a time, invoke "),Tt=o(yn,"A",{href:!0});var vf=n(Tt);Zi=r(vf,"enable_vae_slicing()"),vf.forEach(s),er=r(yn," in your pipeline before inference. For example:"),yn.forEach(s),_o=m(e),_(Ye.$$.fragment,e),vo=m(e),Pt=o(e,"P",{});var bf=n(Pt);tr=r(bf,"You may see a small performance boost in VAE decode on multi-image batches. There should be no performance impact on single-image batches."),bf.forEach(s),bo=m(e),Q=o(e,"H2",{class:!0});var gn=n(Q);Ee=o(gn,"A",{id:!0,class:!0,href:!0});var yf=n(Ee);Bs=o(yf,"SPAN",{});var gf=n(Bs);_(We.$$.fragment,gf),gf.forEach(s),yf.forEach(s),sr=m(gn),Ls=o(gn,"SPAN",{});var wf=n(Ls);ar=r(wf,"Tiled VAE decode and encode for large images"),wf.forEach(s),gn.forEach(s),yo=m(e),At=o(e,"P",{});var $f=n(At);or=r($f,"Tiled VAE processing makes it possible to work with large images on limited VRAM. For example, generating 4k images in 8GB of VRAM. Tiled VAE decoder splits the image into overlapping tiles, decodes the tiles, and blends the outputs to make the final image."),$f.forEach(s),go=m(e),I=o(e,"P",{});var as=n(I);nr=r(as,"You want to couple this with "),Dt=o(as,"A",{href:!0});var Ef=n(Dt);ir=r(Ef,"enable_attention_slicing()"),Ef.forEach(s),rr=r(as," or "),qt=o(as,"A",{href:!0});var jf=n(qt);lr=r(jf,"enable_xformers_memory_efficient_attention()"),jf.forEach(s),pr=r(as," to further minimize memory use."),as.forEach(s),wo=m(e),je=o(e,"P",{});var wn=n(je);fr=r(wn,"To use tiled VAE processing, invoke "),St=o(wn,"A",{href:!0});var kf=n(St);mr=r(kf,"enable_vae_tiling()"),kf.forEach(s),hr=r(wn," in your pipeline before inference. For example:"),wn.forEach(s),$o=m(e),_(Ke.$$.fragment,e),Eo=m(e),xt=o(e,"P",{});var Tf=n(xt);dr=r(Tf,"The output image will have some tile-to-tile tone variation from the tiles having separate decoders, but you shouldn\u2019t see sharp seams between the tiles. The tiling is turned off for images that are 512x512 or smaller."),Tf.forEach(s),jo=m(e),Nt=o(e,"A",{name:!0}),n(Nt).forEach(s),ko=m(e),J=o(e,"H2",{class:!0});var $n=n(J);ke=o($n,"A",{id:!0,class:!0,href:!0});var Pf=n(ke);Xs=o(Pf,"SPAN",{});var Af=n(Xs);_(Qe.$$.fragment,Af),Af.forEach(s),Pf.forEach(s),cr=m($n),Ys=o($n,"SPAN",{});var Df=n(Ys);ur=r(Df,"Offloading to CPU with accelerate for memory savings"),Df.forEach(s),$n.forEach(s),To=m(e),Ut=o(e,"P",{});var qf=n(Ut);_r=r(qf,"For additional memory savings, you can offload the weights to CPU and only load them to GPU when performing the forward pass."),qf.forEach(s),Po=m(e),Te=o(e,"P",{});var En=n(Te);vr=r(En,"To perform CPU offloading, all you have to do is invoke "),Ct=o(En,"A",{href:!0});var Sf=n(Ct);br=r(Sf,"enable_sequential_cpu_offload()"),Sf.forEach(s),yr=r(En,":"),En.forEach(s),Ao=m(e),_(Je.$$.fragment,e),Do=m(e),It=o(e,"P",{});var xf=n(It);gr=r(xf,"And you can get the memory consumption to < 3GB."),xf.forEach(s),qo=m(e),Pe=o(e,"P",{});var jn=n(Pe);wr=r(jn,"Note that this method works at the submodule level, not on whole models. This is the best way to minimize memory consumption, but inference is much slower due to the iterative nature of the process. The UNet component of the pipeline runs several times (as many as "),Ws=o(jn,"CODE",{});var Nf=n(Ws);$r=r(Nf,"num_inference_steps"),Nf.forEach(s),Er=r(jn,"); each time, the different submodules of the UNet are sequentially onloaded and then offloaded as they are needed, so the number of memory transfers is large."),jn.forEach(s),So=m(e),_(Ae.$$.fragment,e),xo=m(e),Ft=o(e,"P",{});var Uf=n(Ft);jr=r(Uf,"It is also possible to chain offloading with attention slicing for minimal memory consumption (< 2GB)."),Uf.forEach(s),No=m(e),_(Ze.$$.fragment,e),Uo=m(e),A=o(e,"P",{});var he=n(A);Ks=o(he,"STRONG",{});var Cf=n(Ks);kr=r(Cf,"Note"),Cf.forEach(s),Tr=r(he,": When using "),Qs=o(he,"CODE",{});var If=n(Qs);Pr=r(If,"enable_sequential_cpu_offload()"),If.forEach(s),Ar=r(he,", it is important to "),Js=o(he,"STRONG",{});var Ff=n(Js);Dr=r(Ff,"not"),Ff.forEach(s),qr=r(he," move the pipeline to CUDA beforehand or else the gain in memory consumption will only be minimal. See "),et=o(he,"A",{href:!0,rel:!0});var Rf=n(et);Sr=r(Rf,"this issue"),Rf.forEach(s),xr=r(he," for more information."),he.forEach(s),Co=m(e),Z=o(e,"P",{});var La=n(Z);Zs=o(La,"STRONG",{});var Vf=n(Zs);Nr=r(Vf,"Note"),Vf.forEach(s),Ur=r(La,": "),ea=o(La,"CODE",{});var Gf=n(ea);Cr=r(Gf,"enable_sequential_cpu_offload()"),Gf.forEach(s),Ir=r(La," is a stateful operation that installs hooks on the models."),La.forEach(s),Io=m(e),Rt=o(e,"A",{name:!0}),n(Rt).forEach(s),Fo=m(e),ee=o(e,"H2",{class:!0});var kn=n(ee);De=o(kn,"A",{id:!0,class:!0,href:!0});var Mf=n(De);ta=o(Mf,"SPAN",{});var zf=n(ta);_(tt.$$.fragment,zf),zf.forEach(s),Mf.forEach(s),Fr=m(kn),sa=o(kn,"SPAN",{});var Hf=n(sa);Rr=r(Hf,"Model offloading for fast inference and memory savings"),Hf.forEach(s),kn.forEach(s),Ro=m(e),st=o(e,"P",{});var jp=n(st);Vt=o(jp,"A",{href:!0});var Of=n(Vt);Vr=r(Of,"Sequential CPU offloading"),Of.forEach(s),Gr=r(jp,", as discussed in the previous section, preserves a lot of memory but makes inference slower, because submodules are moved to GPU as needed, and immediately returned to CPU when a new module runs."),jp.forEach(s),Vo=m(e),F=o(e,"P",{});var os=n(F);Mr=r(os,"Full-model offloading is an alternative that moves whole models to the GPU, instead of handling each model\u2019s constituent "),aa=o(os,"EM",{});var Bf=n(aa);zr=r(Bf,"modules"),Bf.forEach(s),Hr=r(os,". This results in a negligible impact on inference time (compared with moving the pipeline to "),oa=o(os,"CODE",{});var Lf=n(oa);Or=r(Lf,"cuda"),Lf.forEach(s),Br=r(os,"), while still providing some memory savings."),os.forEach(s),Go=m(e),Gt=o(e,"P",{});var Xf=n(Gt);Lr=r(Xf,`In this scenario, only one of the main components of the pipeline (typically: text encoder, unet and vae)
will be in the GPU while the others wait in the CPU. Components like the UNet that run for multiple iterations will stay on GPU until they are no longer needed.`),Xf.forEach(s),Mo=m(e),qe=o(e,"P",{});var Tn=n(qe);Xr=r(Tn,"This feature can be enabled by invoking "),na=o(Tn,"CODE",{});var Yf=n(na);Yr=r(Yf,"enable_model_cpu_offload()"),Yf.forEach(s),Wr=r(Tn," on the pipeline, as shown below."),Tn.forEach(s),zo=m(e),_(at.$$.fragment,e),Ho=m(e),Mt=o(e,"P",{});var Wf=n(Mt);Kr=r(Wf,"This is also compatible with attention slicing for additional memory savings."),Wf.forEach(s),Oo=m(e),_(ot.$$.fragment,e),Bo=m(e),_(Se.$$.fragment,e),Lo=m(e),S=o(e,"P",{});var _t=n(S);ia=o(_t,"STRONG",{});var Kf=n(ia);Qr=r(Kf,"Note"),Kf.forEach(s),Jr=r(_t,": "),ra=o(_t,"CODE",{});var Qf=n(ra);Zr=r(Qf,"enable_model_cpu_offload()"),Qf.forEach(s),el=r(_t,` is a stateful operation that installs hooks on the models and state on the pipeline. In order to properly offload
models after they are called, it is required that the entire pipeline is run and models are called in the order the pipeline expects them to be. Exercise caution
if models are re-used outside the context of the pipeline after hooks have been installed. See `),nt=o(_t,"A",{href:!0,rel:!0});var Jf=n(nt);tl=r(Jf,"accelerate"),Jf.forEach(s),sl=r(_t,`
for further docs on removing hooks.`),_t.forEach(s),Xo=m(e),te=o(e,"H2",{class:!0});var Pn=n(te);xe=o(Pn,"A",{id:!0,class:!0,href:!0});var Zf=n(xe);la=o(Zf,"SPAN",{});var em=n(la);_(it.$$.fragment,em),em.forEach(s),Zf.forEach(s),al=m(Pn),pa=o(Pn,"SPAN",{});var tm=n(pa);ol=r(tm,"Using Channels Last memory format"),tm.forEach(s),Pn.forEach(s),Yo=m(e),zt=o(e,"P",{});var sm=n(zt);nl=r(sm,"Channels last memory format is an alternative way of ordering NCHW tensors in memory preserving dimensions ordering. Channels last tensors ordered in such a way that channels become the densest dimension (aka storing images pixel-per-pixel). Since not all operators currently support channels last format it may result in a worst performance, so it\u2019s better to try it and see if it works for your model."),sm.forEach(s),Wo=m(e),Ht=o(e,"P",{});var am=n(Ht);il=r(am,"For example, in order to set the UNet model in our pipeline to use channels last format, we can use the following:"),am.forEach(s),Ko=m(e),_(rt.$$.fragment,e),Qo=m(e),se=o(e,"H2",{class:!0});var An=n(se);Ne=o(An,"A",{id:!0,class:!0,href:!0});var om=n(Ne);fa=o(om,"SPAN",{});var nm=n(fa);_(lt.$$.fragment,nm),nm.forEach(s),om.forEach(s),rl=m(An),ma=o(An,"SPAN",{});var im=n(ma);ll=r(im,"Tracing"),im.forEach(s),An.forEach(s),Jo=m(e),Ue=o(e,"P",{});var Dn=n(Ue);pl=r(Dn,"Tracing runs an example input tensor through your model, and captures the operations that are invoked as that input makes its way through the model\u2019s layers so that an executable or "),ha=o(Dn,"CODE",{});var rm=n(ha);fl=r(rm,"ScriptFunction"),rm.forEach(s),ml=r(Dn," is returned that will be optimized using just-in-time compilation."),Dn.forEach(s),Zo=m(e),Ot=o(e,"P",{});var lm=n(Ot);hl=r(lm,"To trace our UNet model, we can use the following:"),lm.forEach(s),en=m(e),_(pt.$$.fragment,e),tn=m(e),Ce=o(e,"P",{});var qn=n(Ce);dl=r(qn,"Then we can replace the "),da=o(qn,"CODE",{});var pm=n(da);cl=r(pm,"unet"),pm.forEach(s),ul=r(qn," attribute of the pipeline with the traced model like the following"),qn.forEach(s),sn=m(e),_(ft.$$.fragment,e),an=m(e),ae=o(e,"H2",{class:!0});var Sn=n(ae);Ie=o(Sn,"A",{id:!0,class:!0,href:!0});var fm=n(Ie);ca=o(fm,"SPAN",{});var mm=n(ca);_(mt.$$.fragment,mm),mm.forEach(s),fm.forEach(s),_l=m(Sn),ua=o(Sn,"SPAN",{});var hm=n(ua);vl=r(hm,"Memory Efficient Attention"),hm.forEach(s),Sn.forEach(s),on=m(e),R=o(e,"P",{});var ns=n(R);bl=r(ns,"Recent work on optimizing the bandwitdh in the attention block has generated huge speed ups and gains in GPU memory usage. The most recent being Flash Attention from @tridao: "),ht=o(ns,"A",{href:!0,rel:!0});var dm=n(ht);yl=r(dm,"code"),dm.forEach(s),gl=r(ns,", "),dt=o(ns,"A",{href:!0,rel:!0});var cm=n(dt);wl=r(cm,"paper"),cm.forEach(s),$l=r(ns,"."),ns.forEach(s),nn=m(e),Bt=o(e,"P",{});var um=n(Bt);El=r(um,"Here are the speedups we obtain on a few Nvidia GPUs when running the inference at 512x512 with a batch size of 1 (one prompt):"),um.forEach(s),rn=m(e),Fe=o(e,"TABLE",{});var xn=n(Fe);_a=o(xn,"THEAD",{});var _m=n(_a);oe=o(_m,"TR",{});var is=n(oe);va=o(is,"TH",{});var vm=n(va);jl=r(vm,"GPU"),vm.forEach(s),kl=m(is),ba=o(is,"TH",{});var bm=n(ba);Tl=r(bm,"Base Attention FP16"),bm.forEach(s),Pl=m(is),ya=o(is,"TH",{});var ym=n(ya);Al=r(ym,"Memory Efficient Attention FP16"),ym.forEach(s),is.forEach(s),_m.forEach(s),Dl=m(xn),E=o(xn,"TBODY",{});var k=n(E);ne=o(k,"TR",{});var rs=n(ne);ga=o(rs,"TD",{});var gm=n(ga);ql=r(gm,"NVIDIA Tesla T4"),gm.forEach(s),Sl=m(rs),wa=o(rs,"TD",{});var wm=n(wa);xl=r(wm,"3.5it/s"),wm.forEach(s),Nl=m(rs),$a=o(rs,"TD",{});var $m=n($a);Ul=r($m,"5.5it/s"),$m.forEach(s),rs.forEach(s),Cl=m(k),ie=o(k,"TR",{});var ls=n(ie);Ea=o(ls,"TD",{});var Em=n(Ea);Il=r(Em,"NVIDIA 3060 RTX"),Em.forEach(s),Fl=m(ls),ja=o(ls,"TD",{});var jm=n(ja);Rl=r(jm,"4.6it/s"),jm.forEach(s),Vl=m(ls),ka=o(ls,"TD",{});var km=n(ka);Gl=r(km,"7.8it/s"),km.forEach(s),ls.forEach(s),Ml=m(k),re=o(k,"TR",{});var ps=n(re);Ta=o(ps,"TD",{});var Tm=n(Ta);zl=r(Tm,"NVIDIA A10G"),Tm.forEach(s),Hl=m(ps),Pa=o(ps,"TD",{});var Pm=n(Pa);Ol=r(Pm,"8.88it/s"),Pm.forEach(s),Bl=m(ps),Aa=o(ps,"TD",{});var Am=n(Aa);Ll=r(Am,"15.6it/s"),Am.forEach(s),ps.forEach(s),Xl=m(k),le=o(k,"TR",{});var fs=n(le);Da=o(fs,"TD",{});var Dm=n(Da);Yl=r(Dm,"NVIDIA RTX A6000"),Dm.forEach(s),Wl=m(fs),qa=o(fs,"TD",{});var qm=n(qa);Kl=r(qm,"11.7it/s"),qm.forEach(s),Ql=m(fs),Sa=o(fs,"TD",{});var Sm=n(Sa);Jl=r(Sm,"21.09it/s"),Sm.forEach(s),fs.forEach(s),Zl=m(k),pe=o(k,"TR",{});var ms=n(pe);xa=o(ms,"TD",{});var xm=n(xa);ep=r(xm,"NVIDIA TITAN RTX"),xm.forEach(s),tp=m(ms),Na=o(ms,"TD",{});var Nm=n(Na);sp=r(Nm,"12.51it/s"),Nm.forEach(s),ap=m(ms),Ua=o(ms,"TD",{});var Um=n(Ua);op=r(Um,"18.22it/s"),Um.forEach(s),ms.forEach(s),np=m(k),fe=o(k,"TR",{});var hs=n(fe);Ca=o(hs,"TD",{});var Cm=n(Ca);ip=r(Cm,"A100-SXM4-40GB"),Cm.forEach(s),rp=m(hs),Ia=o(hs,"TD",{});var Im=n(Ia);lp=r(Im,"18.6it/s"),Im.forEach(s),pp=m(hs),Fa=o(hs,"TD",{});var Fm=n(Fa);fp=r(Fm,"29.it/s"),Fm.forEach(s),hs.forEach(s),mp=m(k),me=o(k,"TR",{});var ds=n(me);Ra=o(ds,"TD",{});var Rm=n(Ra);hp=r(Rm,"A100-SXM-80GB"),Rm.forEach(s),dp=m(ds),Va=o(ds,"TD",{});var Vm=n(Va);cp=r(Vm,"18.7it/s"),Vm.forEach(s),up=m(ds),Ga=o(ds,"TD",{});var Gm=n(Ga);_p=r(Gm,"29.5it/s"),Gm.forEach(s),ds.forEach(s),k.forEach(s),xn.forEach(s),ln=m(e),Lt=o(e,"P",{});var Mm=n(Lt);vp=r(Mm,"To leverage it just make sure you have:"),Mm.forEach(s),pn=m(e),V=o(e,"UL",{});var cs=n(V);Ma=o(cs,"LI",{});var zm=n(Ma);bp=r(zm,"PyTorch > 1.12"),zm.forEach(s),yp=m(cs),za=o(cs,"LI",{});var Hm=n(za);gp=r(Hm,"Cuda available"),Hm.forEach(s),wp=m(cs),Xt=o(cs,"LI",{});var kp=n(Xt);Yt=o(kp,"A",{href:!0});var Om=n(Yt);$p=r(Om,"Installed the xformers library"),Om.forEach(s),Ep=r(kp,"."),kp.forEach(s),cs.forEach(s),fn=m(e),_(ct.$$.fragment,e),this.h()},h(){h(c,"name","hf:doc:metadata"),h(c,"content",JSON.stringify(th)),h(T,"id","memory-and-speed"),h(T,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(T,"href","#memory-and-speed"),h(w,"class","relative group"),h(Ve,"href","https://github.com/facebookresearch/xformers"),h(Ve,"rel","nofollow"),h(vt,"href","xformers"),h(ce,"id","use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices"),h(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ce,"href","#use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices"),h(X,"class","relative group"),h(Me,"href","https://huggingface.co/docs/transformers/v4.18.0/en/performance#tf32"),h(Me,"rel","nofollow"),h(_e,"id","half-precision-weights"),h(_e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(_e,"href","#half-precision-weights"),h(Y,"class","relative group"),h(be,"id","sliced-attention-for-additional-memory-savings"),h(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(be,"href","#sliced-attention-for-additional-memory-savings"),h(W,"class","relative group"),h(wt,"href","/docs/diffusers/pr_3274/en/api/pipelines/stable_diffusion/upscale#diffusers.StableDiffusionUpscalePipeline.enable_attention_slicing"),h(we,"id","sliced-vae-decode-for-larger-batches"),h(we,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(we,"href","#sliced-vae-decode-for-larger-batches"),h(K,"class","relative group"),h(jt,"href","/docs/diffusers/pr_3274/en/api/pipelines/stable_diffusion/upscale#diffusers.StableDiffusionUpscalePipeline.enable_attention_slicing"),h(kt,"href","/docs/diffusers/pr_3274/en/api/pipelines/stable_diffusion/upscale#diffusers.StableDiffusionUpscalePipeline.enable_xformers_memory_efficient_attention"),h(Tt,"href","/docs/diffusers/pr_3274/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.enable_vae_slicing"),h(Ee,"id","tiled-vae-decode-and-encode-for-large-images"),h(Ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Ee,"href","#tiled-vae-decode-and-encode-for-large-images"),h(Q,"class","relative group"),h(Dt,"href","/docs/diffusers/pr_3274/en/api/pipelines/stable_diffusion/upscale#diffusers.StableDiffusionUpscalePipeline.enable_attention_slicing"),h(qt,"href","/docs/diffusers/pr_3274/en/api/pipelines/stable_diffusion/upscale#diffusers.StableDiffusionUpscalePipeline.enable_xformers_memory_efficient_attention"),h(St,"href","/docs/diffusers/pr_3274/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.enable_vae_tiling"),h(Nt,"name","sequential_offloading"),h(ke,"id","offloading-to-cpu-with-accelerate-for-memory-savings"),h(ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(ke,"href","#offloading-to-cpu-with-accelerate-for-memory-savings"),h(J,"class","relative group"),h(Ct,"href","/docs/diffusers/pr_3274/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.enable_sequential_cpu_offload"),h(et,"href","https://github.com/huggingface/diffusers/issues/1934"),h(et,"rel","nofollow"),h(Rt,"name","model_offloading"),h(De,"id","model-offloading-for-fast-inference-and-memory-savings"),h(De,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(De,"href","#model-offloading-for-fast-inference-and-memory-savings"),h(ee,"class","relative group"),h(Vt,"href","#sequential_offloading"),h(nt,"href","https://huggingface.co/docs/accelerate/v0.18.0/en/package_reference/big_modeling#accelerate.hooks.remove_hook_from_module"),h(nt,"rel","nofollow"),h(xe,"id","using-channels-last-memory-format"),h(xe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(xe,"href","#using-channels-last-memory-format"),h(te,"class","relative group"),h(Ne,"id","tracing"),h(Ne,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Ne,"href","#tracing"),h(se,"class","relative group"),h(Ie,"id","memory-efficient-attention"),h(Ie,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(Ie,"href","#memory-efficient-attention"),h(ae,"class","relative group"),h(ht,"href","https://github.com/HazyResearch/flash-attention"),h(ht,"rel","nofollow"),h(dt,"href","https://arxiv.org/pdf/2205.14135.pdf"),h(dt,"rel","nofollow"),h(Yt,"href","xformers")},m(e,l){t(document.head,c),p(e,d,l),p(e,w,l),t(w,T),t(T,$),v(j,$,null),t(w,Un),t(w,us),t(us,Cn),p(e,Xa,l),p(e,q,l),t(q,In),t(q,_s),t(_s,Fn),t(q,Rn),t(q,Ve),t(Ve,Vn),t(q,Gn),t(q,vt),t(vt,Mn),t(q,zn),p(e,Ya,l),p(e,bt,l),t(bt,Hn),p(e,Wa,l),p(e,de,l),t(de,vs),t(vs,M),t(M,Ka),t(M,On),t(M,bs),t(bs,Bn),t(M,Ln),t(M,ys),t(ys,Xn),t(de,Yn),t(de,P),t(P,z),t(z,gs),t(gs,Wn),t(z,Kn),t(z,ws),t(ws,Qn),t(z,Jn),t(z,$s),t($s,Zn),t(P,ei),t(P,H),t(H,Es),t(Es,ti),t(H,si),t(H,js),t(js,ai),t(H,oi),t(H,ks),t(ks,ni),t(P,ii),t(P,O),t(O,Ts),t(Ts,ri),t(O,li),t(O,Ps),t(Ps,pi),t(O,fi),t(O,As),t(As,mi),t(P,hi),t(P,B),t(B,Ds),t(Ds,di),t(B,ci),t(B,qs),t(qs,ui),t(B,_i),t(B,Ss),t(Ss,vi),t(P,bi),t(P,L),t(L,xs),t(xs,yi),t(L,gi),t(L,Ns),t(Ns,wi),t(L,$i),t(L,Us),t(Us,Ei),p(e,Qa,l),p(e,yt,l),t(yt,ji),p(e,Ja,l),p(e,X,l),t(X,ce),t(ce,Cs),v(Ge,Cs,null),t(X,ki),t(X,Is),t(Is,Ti),p(e,Za,l),p(e,ue,l),t(ue,Pi),t(ue,Me),t(Me,Ai),t(ue,Di),p(e,eo,l),v(ze,e,l),p(e,to,l),p(e,Y,l),t(Y,_e),t(_e,Fs),v(He,Fs,null),t(Y,qi),t(Y,Rs),t(Rs,Si),p(e,so,l),p(e,U,l),t(U,xi),t(U,Vs),t(Vs,Ni),t(U,Ui),t(U,Gs),t(Gs,Ci),t(U,Ii),p(e,ao,l),v(Oe,e,l),p(e,oo,l),v(ve,e,l),p(e,no,l),p(e,W,l),t(W,be),t(be,Ms),v(Be,Ms,null),t(W,Fi),t(W,zs),t(zs,Ri),p(e,io,l),p(e,gt,l),t(gt,Vi),p(e,ro,l),v(ye,e,l),p(e,lo,l),p(e,ge,l),t(ge,Gi),t(ge,wt),t(wt,Mi),t(ge,zi),p(e,po,l),v(Le,e,l),p(e,fo,l),p(e,$t,l),t($t,Hi),p(e,mo,l),p(e,K,l),t(K,we),t(we,Hs),v(Xe,Hs,null),t(K,Oi),t(K,Os),t(Os,Bi),p(e,ho,l),p(e,Et,l),t(Et,Li),p(e,co,l),p(e,C,l),t(C,Xi),t(C,jt),t(jt,Yi),t(C,Wi),t(C,kt),t(kt,Ki),t(C,Qi),p(e,uo,l),p(e,$e,l),t($e,Ji),t($e,Tt),t(Tt,Zi),t($e,er),p(e,_o,l),v(Ye,e,l),p(e,vo,l),p(e,Pt,l),t(Pt,tr),p(e,bo,l),p(e,Q,l),t(Q,Ee),t(Ee,Bs),v(We,Bs,null),t(Q,sr),t(Q,Ls),t(Ls,ar),p(e,yo,l),p(e,At,l),t(At,or),p(e,go,l),p(e,I,l),t(I,nr),t(I,Dt),t(Dt,ir),t(I,rr),t(I,qt),t(qt,lr),t(I,pr),p(e,wo,l),p(e,je,l),t(je,fr),t(je,St),t(St,mr),t(je,hr),p(e,$o,l),v(Ke,e,l),p(e,Eo,l),p(e,xt,l),t(xt,dr),p(e,jo,l),p(e,Nt,l),p(e,ko,l),p(e,J,l),t(J,ke),t(ke,Xs),v(Qe,Xs,null),t(J,cr),t(J,Ys),t(Ys,ur),p(e,To,l),p(e,Ut,l),t(Ut,_r),p(e,Po,l),p(e,Te,l),t(Te,vr),t(Te,Ct),t(Ct,br),t(Te,yr),p(e,Ao,l),v(Je,e,l),p(e,Do,l),p(e,It,l),t(It,gr),p(e,qo,l),p(e,Pe,l),t(Pe,wr),t(Pe,Ws),t(Ws,$r),t(Pe,Er),p(e,So,l),v(Ae,e,l),p(e,xo,l),p(e,Ft,l),t(Ft,jr),p(e,No,l),v(Ze,e,l),p(e,Uo,l),p(e,A,l),t(A,Ks),t(Ks,kr),t(A,Tr),t(A,Qs),t(Qs,Pr),t(A,Ar),t(A,Js),t(Js,Dr),t(A,qr),t(A,et),t(et,Sr),t(A,xr),p(e,Co,l),p(e,Z,l),t(Z,Zs),t(Zs,Nr),t(Z,Ur),t(Z,ea),t(ea,Cr),t(Z,Ir),p(e,Io,l),p(e,Rt,l),p(e,Fo,l),p(e,ee,l),t(ee,De),t(De,ta),v(tt,ta,null),t(ee,Fr),t(ee,sa),t(sa,Rr),p(e,Ro,l),p(e,st,l),t(st,Vt),t(Vt,Vr),t(st,Gr),p(e,Vo,l),p(e,F,l),t(F,Mr),t(F,aa),t(aa,zr),t(F,Hr),t(F,oa),t(oa,Or),t(F,Br),p(e,Go,l),p(e,Gt,l),t(Gt,Lr),p(e,Mo,l),p(e,qe,l),t(qe,Xr),t(qe,na),t(na,Yr),t(qe,Wr),p(e,zo,l),v(at,e,l),p(e,Ho,l),p(e,Mt,l),t(Mt,Kr),p(e,Oo,l),v(ot,e,l),p(e,Bo,l),v(Se,e,l),p(e,Lo,l),p(e,S,l),t(S,ia),t(ia,Qr),t(S,Jr),t(S,ra),t(ra,Zr),t(S,el),t(S,nt),t(nt,tl),t(S,sl),p(e,Xo,l),p(e,te,l),t(te,xe),t(xe,la),v(it,la,null),t(te,al),t(te,pa),t(pa,ol),p(e,Yo,l),p(e,zt,l),t(zt,nl),p(e,Wo,l),p(e,Ht,l),t(Ht,il),p(e,Ko,l),v(rt,e,l),p(e,Qo,l),p(e,se,l),t(se,Ne),t(Ne,fa),v(lt,fa,null),t(se,rl),t(se,ma),t(ma,ll),p(e,Jo,l),p(e,Ue,l),t(Ue,pl),t(Ue,ha),t(ha,fl),t(Ue,ml),p(e,Zo,l),p(e,Ot,l),t(Ot,hl),p(e,en,l),v(pt,e,l),p(e,tn,l),p(e,Ce,l),t(Ce,dl),t(Ce,da),t(da,cl),t(Ce,ul),p(e,sn,l),v(ft,e,l),p(e,an,l),p(e,ae,l),t(ae,Ie),t(Ie,ca),v(mt,ca,null),t(ae,_l),t(ae,ua),t(ua,vl),p(e,on,l),p(e,R,l),t(R,bl),t(R,ht),t(ht,yl),t(R,gl),t(R,dt),t(dt,wl),t(R,$l),p(e,nn,l),p(e,Bt,l),t(Bt,El),p(e,rn,l),p(e,Fe,l),t(Fe,_a),t(_a,oe),t(oe,va),t(va,jl),t(oe,kl),t(oe,ba),t(ba,Tl),t(oe,Pl),t(oe,ya),t(ya,Al),t(Fe,Dl),t(Fe,E),t(E,ne),t(ne,ga),t(ga,ql),t(ne,Sl),t(ne,wa),t(wa,xl),t(ne,Nl),t(ne,$a),t($a,Ul),t(E,Cl),t(E,ie),t(ie,Ea),t(Ea,Il),t(ie,Fl),t(ie,ja),t(ja,Rl),t(ie,Vl),t(ie,ka),t(ka,Gl),t(E,Ml),t(E,re),t(re,Ta),t(Ta,zl),t(re,Hl),t(re,Pa),t(Pa,Ol),t(re,Bl),t(re,Aa),t(Aa,Ll),t(E,Xl),t(E,le),t(le,Da),t(Da,Yl),t(le,Wl),t(le,qa),t(qa,Kl),t(le,Ql),t(le,Sa),t(Sa,Jl),t(E,Zl),t(E,pe),t(pe,xa),t(xa,ep),t(pe,tp),t(pe,Na),t(Na,sp),t(pe,ap),t(pe,Ua),t(Ua,op),t(E,np),t(E,fe),t(fe,Ca),t(Ca,ip),t(fe,rp),t(fe,Ia),t(Ia,lp),t(fe,pp),t(fe,Fa),t(Fa,fp),t(E,mp),t(E,me),t(me,Ra),t(Ra,hp),t(me,dp),t(me,Va),t(Va,cp),t(me,up),t(me,Ga),t(Ga,_p),p(e,ln,l),p(e,Lt,l),t(Lt,vp),p(e,pn,l),p(e,V,l),t(V,Ma),t(Ma,bp),t(V,yp),t(V,za),t(za,gp),t(V,wp),t(V,Xt),t(Xt,Yt),t(Yt,$p),t(Xt,Ep),p(e,fn,l),v(ct,e,l),mn=!0},p(e,[l]){const ut={};l&2&&(ut.$$scope={dirty:l,ctx:e}),ve.$set(ut);const Ha={};l&2&&(Ha.$$scope={dirty:l,ctx:e}),ye.$set(Ha);const Oa={};l&2&&(Oa.$$scope={dirty:l,ctx:e}),Ae.$set(Oa);const Ba={};l&2&&(Ba.$$scope={dirty:l,ctx:e}),Se.$set(Ba)},i(e){mn||(b(j.$$.fragment,e),b(Ge.$$.fragment,e),b(ze.$$.fragment,e),b(He.$$.fragment,e),b(Oe.$$.fragment,e),b(ve.$$.fragment,e),b(Be.$$.fragment,e),b(ye.$$.fragment,e),b(Le.$$.fragment,e),b(Xe.$$.fragment,e),b(Ye.$$.fragment,e),b(We.$$.fragment,e),b(Ke.$$.fragment,e),b(Qe.$$.fragment,e),b(Je.$$.fragment,e),b(Ae.$$.fragment,e),b(Ze.$$.fragment,e),b(tt.$$.fragment,e),b(at.$$.fragment,e),b(ot.$$.fragment,e),b(Se.$$.fragment,e),b(it.$$.fragment,e),b(rt.$$.fragment,e),b(lt.$$.fragment,e),b(pt.$$.fragment,e),b(ft.$$.fragment,e),b(mt.$$.fragment,e),b(ct.$$.fragment,e),mn=!0)},o(e){y(j.$$.fragment,e),y(Ge.$$.fragment,e),y(ze.$$.fragment,e),y(He.$$.fragment,e),y(Oe.$$.fragment,e),y(ve.$$.fragment,e),y(Be.$$.fragment,e),y(ye.$$.fragment,e),y(Le.$$.fragment,e),y(Xe.$$.fragment,e),y(Ye.$$.fragment,e),y(We.$$.fragment,e),y(Ke.$$.fragment,e),y(Qe.$$.fragment,e),y(Je.$$.fragment,e),y(Ae.$$.fragment,e),y(Ze.$$.fragment,e),y(tt.$$.fragment,e),y(at.$$.fragment,e),y(ot.$$.fragment,e),y(Se.$$.fragment,e),y(it.$$.fragment,e),y(rt.$$.fragment,e),y(lt.$$.fragment,e),y(pt.$$.fragment,e),y(ft.$$.fragment,e),y(mt.$$.fragment,e),y(ct.$$.fragment,e),mn=!1},d(e){s(c),e&&s(d),e&&s(w),g(j),e&&s(Xa),e&&s(q),e&&s(Ya),e&&s(bt),e&&s(Wa),e&&s(de),e&&s(Qa),e&&s(yt),e&&s(Ja),e&&s(X),g(Ge),e&&s(Za),e&&s(ue),e&&s(eo),g(ze,e),e&&s(to),e&&s(Y),g(He),e&&s(so),e&&s(U),e&&s(ao),g(Oe,e),e&&s(oo),g(ve,e),e&&s(no),e&&s(W),g(Be),e&&s(io),e&&s(gt),e&&s(ro),g(ye,e),e&&s(lo),e&&s(ge),e&&s(po),g(Le,e),e&&s(fo),e&&s($t),e&&s(mo),e&&s(K),g(Xe),e&&s(ho),e&&s(Et),e&&s(co),e&&s(C),e&&s(uo),e&&s($e),e&&s(_o),g(Ye,e),e&&s(vo),e&&s(Pt),e&&s(bo),e&&s(Q),g(We),e&&s(yo),e&&s(At),e&&s(go),e&&s(I),e&&s(wo),e&&s(je),e&&s($o),g(Ke,e),e&&s(Eo),e&&s(xt),e&&s(jo),e&&s(Nt),e&&s(ko),e&&s(J),g(Qe),e&&s(To),e&&s(Ut),e&&s(Po),e&&s(Te),e&&s(Ao),g(Je,e),e&&s(Do),e&&s(It),e&&s(qo),e&&s(Pe),e&&s(So),g(Ae,e),e&&s(xo),e&&s(Ft),e&&s(No),g(Ze,e),e&&s(Uo),e&&s(A),e&&s(Co),e&&s(Z),e&&s(Io),e&&s(Rt),e&&s(Fo),e&&s(ee),g(tt),e&&s(Ro),e&&s(st),e&&s(Vo),e&&s(F),e&&s(Go),e&&s(Gt),e&&s(Mo),e&&s(qe),e&&s(zo),g(at,e),e&&s(Ho),e&&s(Mt),e&&s(Oo),g(ot,e),e&&s(Bo),g(Se,e),e&&s(Lo),e&&s(S),e&&s(Xo),e&&s(te),g(it),e&&s(Yo),e&&s(zt),e&&s(Wo),e&&s(Ht),e&&s(Ko),g(rt,e),e&&s(Qo),e&&s(se),g(lt),e&&s(Jo),e&&s(Ue),e&&s(Zo),e&&s(Ot),e&&s(en),g(pt,e),e&&s(tn),e&&s(Ce),e&&s(sn),g(ft,e),e&&s(an),e&&s(ae),g(mt),e&&s(on),e&&s(R),e&&s(nn),e&&s(Bt),e&&s(rn),e&&s(Fe),e&&s(ln),e&&s(Lt),e&&s(pn),e&&s(V),e&&s(fn),g(ct,e)}}}const th={local:"memory-and-speed",sections:[{local:null,sections:[{local:"use-tf32-instead-of-fp32-on-ampere-and-later-cuda-devices",title:"Use tf32 instead of fp32 (on Ampere and later CUDA devices)"}],title:null},{local:"half-precision-weights",title:"Half precision weights"},{local:"sliced-attention-for-additional-memory-savings",title:"Sliced attention for additional memory savings"},{local:"sliced-vae-decode-for-larger-batches",title:"Sliced VAE decode for larger batches"},{local:"tiled-vae-decode-and-encode-for-large-images",title:"Tiled VAE decode and encode for large images"},{local:"offloading-to-cpu-with-accelerate-for-memory-savings",title:"Offloading to CPU with accelerate for memory savings"},{local:"model-offloading-for-fast-inference-and-memory-savings",title:"Model offloading for fast inference and memory savings"},{local:"using-channels-last-memory-format",title:"Using Channels Last memory format"},{local:"tracing",title:"Tracing"},{local:"memory-efficient-attention",title:"Memory Efficient Attention"}],title:"Memory and speed"};function sh(N){return Wm(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class rh extends Bm{constructor(c){super();Lm(this,c,sh,eh,Xm,{})}}export{rh as default,th as metadata};
